/*
 * @(#)src/classes/sov/com/ibm/jvm/dump/DvAddressException.java, ras, dumpviewer 1.1
 * ===========================================================================
 * IBM Confidential
 * OCO Source Materials
 *
 * IBM Java(tm)2 SDK, Standard Edition, v 1.3.1
 * (C) Copyright IBM Corp. 1998, 2001.
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright office.
 * ===========================================================================
 */

/*
 *
 * ===========================================================================
 *
 *
 *
 * ===========================================================================
 * Change activity:
 *
 * Reason  Date   Origin  Description
 * ------  ----   ------  ----------------------------------------------------
 * 36524   150502 PHILR:  New for feature 36524
 *
 *
 * ===========================================================================
 * Module Information:
 *
 * DESCRIPTION: Abstract class
 * ===========================================================================
 */
package com.ibm.jvm.dump;

 /**
  *  Description: DVAddress stores addresses internally as java longs
  *               which are 64bits in length and signed. We utilise
  *               these longs to map 64 bit addresses (so we play some
  *               games with the sign). But if the user attempts to
  *               for example increment a DvAddress or add two DvAddresses
  *               together such that we go beyond 64bit addressing then
  *               we will throw a DvAddressException.
  *
  */
public class DvAddressException extends java.lang.Exception {

  public DvAddressException(String s) {
    super(s);
  }

}
