/*
 * @(#)src/classes/sov/com/ibm/jvm/dump/DvAddressSpace.java, ras, dumpviewer 1.14
 * ===========================================================================
 * IBM Confidential
 * OCO Source Materials
 *
 * IBM Java(tm)2 SDK, Standard Edition, v 1.3.1
 * (C) Copyright IBM Corp. 1998, 2001.
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright office.
 * ===========================================================================
 */

/*
 *
 * ===========================================================================
 *
 *
 *
 * ===========================================================================
 * Change activity:
 *
 * Reason  Date   Origin  Description
 * ------  ----   ------  ----------------------------------------------------
 * 36524  020502  PHILR:  New for feature 36524
 * 36524  210502  philr   getCurrentProcess added
 *
 * ===========================================================================
 * Module Information:
 *
 * DESCRIPTION: Abstract class
 * ===========================================================================
 */

package com.ibm.jvm.dump;

/**
 *  Description: Whats the purpose of this class
 */
public abstract class DvAddressSpace {

    /**
     *    Description:
     *
     */
    public abstract DvMemRanges[] getMemRanges();

    /**
     *  Description:
     *
     */
    public abstract DvProcess[] getProcesses();

    /**
     *  Description:
     *
     */
    public abstract DvProcess getCurrentProcess();

    /**
     *   Description:
     */
    public abstract DvAddress  createAddress(long theAddr);

    /**
     *   Description:
     */
    public byte[] getMetaData() { return null; }

    /**
     *   Description: Read a section of memory given an address and a length
     */
    public abstract byte[] readBytes(DvAddress address,long len) throws DvAddressException;

    /**
     *   Description: Read a section of memory given an address as a long
     *                   and a length. Enhancement of abstrat readbytes that
     *                   takes in DvAddress and long.
     */
    public byte[] readBytes(long address,long len) throws DvAddressException {

        DvAddress a = createAddress(address);
        return  readBytes(a,len);

    }

    /**
     *   Description: Read 1 byte from memory
     */
    public abstract byte readByte(DvAddress address) throws DvAddressException;

    /**
     *   Description: Read a java int from memory (4 bytes)
     */
    public abstract int readInt(DvAddress address) throws DvAddressException;

    /**
     *   Description: Read a java long from memory (8 bytes)
     */
    public abstract long readLong(DvAddress address) throws DvAddressException;

    /**
     *   Description: Read a java short from memory (2 bytes)
     */
    public abstract short readShort(DvAddress address) throws DvAddressException;

    /**
     *   Description: Read a pointer from memory (4 or 8 bytes depending on system)
     */
    public abstract DvAddress readPointer(DvAddress address) throws DvAddressException;

    public abstract int pointerSize();

    /**
     *   Description:
     */
    public abstract String id();

}
