/*
 * @(#)src/classes/sov/com/ibm/jvm/dump/DvConstants.java, ras, dumpviewer 1.6
 * ===========================================================================
 * IBM Confidential
 * OCO Source Materials
 *
 * IBM Java(tm)2 SDK, Standard Edition, v 1.3.1
 * (C) Copyright IBM Corp. 1998, 2001.
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright office.
 * ===========================================================================
 */

/*
 *
 * ===========================================================================
 *
 *
 *
 * ===========================================================================
 * Change activity:
 *
 * Reason  Date   Origin  Description
 * ------  ----   ------  ----------------------------------------------------
 * 36524  020502 PHILR:  New for feature 36524

 *
 * ===========================================================================
 * Module Information:
 *
 * DESCRIPTION:
 * ===========================================================================
 */

package com.ibm.jvm.dump;

 /**
  *  Description: Whats the purpose of this class
  *
  *
  *
  *
  *
  */
public class DvConstants {

    static final int FRAME_IS_RESIZEABLE = 1;
    static final int FRAME_IS_CLOSEABLE  = 2;
    static final int FRAME_IS_MAXIMIZEABLE = 4;
    static final int FRAME_IS_ICONIFIABLE = 8;

    static final int FRAMETYPE_IS_MASTER=1;
    static final int FRAMETYPE_IS_TRACE=2;
    static final int FRAMETYPE_IS_WM=3;
    static final int FRAMETYPE_IS_NORMAL=0;
    static final int FRAMETYPE_IS_STATUSLINE=4;
    static final int FRAMETYPE_IS_MMAP=5;
    static final int FRAMETYPE_IS_MS=6;

    static final int ANSWER_UNKNOWN = -1;
    static final int ARCH_IS_32BIT = 1;
    static final int ARCH_IS_64BIT = 2;
    static final int ARCH_IS_BIGENDIAN = 4;
    static final int ARCH_IS_LITTLEENDIAN = 8;

    static String[] ARCH_DESCRIPTIONS={"32-bit ","64-bit ","BigEndian ","LittleEndian "} ;

    static final short ACCESS_STATIC   = 0x0008;
    static final short ACCESS_PUBLIC      = 0x0001;
    static final short ACCESS_PRIVATE     = 0x0002;
    static final short ACCESS_PROTECTED   = 0x0004;
    static final short ACCESS_FINAL       = 0x0010;
    static final short ACCESS_SYNCHRONIZED= 0x0020;
    static final short ACCESS_SUPER       = 0x0020;
    static final short ACCESS_VOLATILE    = 0x0040;
    static final short ACCESS_TRANSIENT   = 0x0080;
    static final short ACCESS_NATIVE      = 0x0100;
    static final short ACCESS_INTERFACE   = 0x0200;
    static final short ACCESS_ABSTRACT    = 0x0400;
    static final short ACCESS_STRICT      = 0x0800;

    static final short HEAP_MID = -1;
    static final short HEAP_ACS = -2;
    static final short HEAP_TRANS = -3;
    static final short HEAP_SYS = -4;
    // Note subsequent -ve values are more System Heaps...

    public static String interpretAccess(short access_flags) {
        String retString = "";

        if (ACCESS_STATIC == (ACCESS_STATIC & access_flags)) {
            retString += " static ";
        }

        if (ACCESS_PUBLIC == (ACCESS_PUBLIC & access_flags)) {
            retString += " public ";
        }
        if (ACCESS_PRIVATE == (ACCESS_PRIVATE & access_flags)) {
            retString += " private ";
        }
        if (ACCESS_PROTECTED == (ACCESS_PROTECTED & access_flags)) {
            retString += " protected ";
        }
        if (ACCESS_FINAL == (ACCESS_FINAL & access_flags)) {
            retString += " final ";
        }
        if (ACCESS_SYNCHRONIZED == (ACCESS_SYNCHRONIZED & access_flags)) {
            retString += " synchronized ";
        }
        if (ACCESS_SUPER == (ACCESS_SUPER & access_flags)) {
            retString += " super ";
        }
        if (ACCESS_VOLATILE == (ACCESS_VOLATILE & access_flags)) {
            retString += " volatile ";
        }
        if (ACCESS_TRANSIENT == (ACCESS_TRANSIENT & access_flags)) {
            retString += " transient ";
        }
        if (ACCESS_NATIVE == (ACCESS_NATIVE & access_flags)) {
            retString += " native ";
        }
        if (ACCESS_INTERFACE == (ACCESS_INTERFACE & access_flags)) {
            retString += " interface ";
        }
        if (ACCESS_ABSTRACT == (ACCESS_ABSTRACT & access_flags)) {
            retString += " abstract ";
        }
        if (ACCESS_STRICT == (ACCESS_STRICT & access_flags)) {
            retString += " steict ";
        }
        return retString;
    }


}
