/*
 * @(#)src/classes/sov/com/ibm/jvm/dump/DvEnvData.java, ras, dumpviewer 1.9
 * ===========================================================================
 * IBM Confidential
 * OCO Source Materials
 *
 * IBM Java(tm)2 SDK, Standard Edition, v 1.3.1
 * (C) Copyright IBM Corp. 1998, 2001.
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright office.
 * ===========================================================================
 */

/*
 *
 * ===========================================================================
 *
 *
 *
 * ===========================================================================
 * Change activity:
 *
 * Reason  Date   Origin  Description
 * ------  ----   ------  ----------------------------------------------------
 * 36524  020502  philr   New for feature 36524
 *
 *
 * ===========================================================================
 * Module Information:
 *
 * DESCRIPTION:
 * ===========================================================================
 */

package com.ibm.jvm.dump;

import java.util.*;

 /**
  *  Description: Whats the purpose of this class
  *
  *
  *
  *
  *
  */
public abstract class DvEnvData {



 public abstract String javaHomeDir();
 public abstract String javaDllDir();
 public abstract String javaVersion();
 public abstract Vector envVars();
 public abstract String classpath();
 public abstract byte[] getMetadata();

 /**
  *  Nicely format the environment data
  *
  */
 public String toString() {
    String retString = ("\nEnvironment data\n"+
                        "================\n");

    String sWork;
    byte[] m = this.getMetadata();

    if (null != m) {
        sWork = new String(m);
        retString +="\n  Metadata: "+sWork+"\n";
    }

    sWork = this.javaVersion();
    if (null !=  sWork) {
        retString += "\n  Java Version   : ";
        retString += sWork;
    }
    else {
        retString += "\n ---No java version information obtained---";
    }

    sWork = this.javaHomeDir();
    if (null !=  sWork) {
        retString += "\n  Java HomeDir   : ";
        retString += sWork;
    }
    else {
        retString += "\n ---No java home directory obtained---";
    }


    sWork = this.javaDllDir();
    if (null !=  sWork) {
        retString += "\n  Java DllDir    : ";
        retString += sWork;
    }
    else {
        retString += "\n ---No java dll directory obtained---";
    }

    sWork = this.classpath();
    if (null !=  sWork) {
        retString += "\n  Java classpath : ";
        retString += sWork;
    }
    else {
        retString += "\n ---No java classpath obtained---";
    }



    Vector v = this.envVars();
    if (null != v) {
        retString += "\n\n environment ....: \n";
        for (int i=0;i<v.size();i++) {
            String vString = "\n" + (String)v.get(i);
            retString += vString;

        }
    }
    else {
        retString += "\n ---No environment variables obtained---";
    }

    return retString;

 }
}
