/*
 * @(#)src/classes/sov/com/ibm/jvm/dump/DvModule.java, ras, dumpviewer 1.4
 * ===========================================================================
 * IBM Confidential
 * OCO Source Materials
 *
 * IBM Java(tm)2 SDK, Standard Edition, v 1.3.1
 * (C) Copyright IBM Corp. 1998, 2001.
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright office.
 * ===========================================================================
 */

/*
 *
 * ===========================================================================
 *
 *
 *
 * ===========================================================================
 * Change activity:
 *
 * Reason  Date   Origin  Description
 * ------  ----   ------  ----------------------------------------------------
 * 36524  210502  philr   New for feature 36524
 * 41452  240502  nmasson Change private to protected
 * 41452  240502  nmasson Add ModuleType
 *
 * ===========================================================================
 * Module Information:
 *
 * DESCRIPTION:
 * ===========================================================================
 */

package com.ibm.jvm.dump;

 /**
  *  Description: Whats the purpose of this class
  *
  *
  *
  *
  *
  */
public class DvModule {

    final static int MODULE_IS_UNDETERMINED = 0;
    final static int MODULE_IS_TEXT = 1;
    final static int MODULE_IS_DATA = 2;

    protected DvAddress moduleAddress; // address in memory
    protected String    moduleName;
    protected long      moduleSize;
    protected int       moduleType = 0;

    public DvModule(DvAddress a,String name, long size, int type) {
        moduleAddress = a;
        moduleName = name;
        moduleSize = size;
        moduleType = type;
        DvUtils.trace("\tNew DvModule created.. "+ name +
                    ": @0x"+Long.toHexString(moduleAddress.getAddressAsLong())+
                    ":" + size,0,false);
    }

    public DvModule() {
    }

    public DvAddress address() { return moduleAddress;}
    public String name() { return moduleName ;}
    public long size() {return moduleSize;}

    /**
     *  Nicely format the loaded data
     *
     */
    public String toString() {

        String retString = "";

        retString = retString += ("\t"+this.name()+"\n");
        retString = retString +=("\t\t at 0x"+
                        Long.toHexString(this.address().getAddressAsLong()) +
                        " \tlength="+ this.size());




        return retString;
    }

}
