/*
 * @(#)src/classes/sov/com/ibm/jvm/dump/DvProcess.java, ras, dumpviewer 1.9
 * ===========================================================================
 * IBM Confidential
 * OCO Source Materials
 *
 * IBM Java(tm)2 SDK, Standard Edition, v 1.3.1
 * (C) Copyright IBM Corp. 1998, 2001.
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright office.
 * ===========================================================================
 */

/*
 *
 * ===========================================================================
 *
 *
 *
 * ===========================================================================
 * Change activity:
 *
 * Reason  Date   Origin  Description
 * ------  ----   ------  ----------------------------------------------------
 * 36524  020502  PHILR:  New for feature 36524
 * 36524  010702  philr:  Added in getSignal()
 *
 * ===========================================================================
 * Module Information:
 *
 * DESCRIPTION:
 * ===========================================================================
 */

package com.ibm.jvm.dump;

 /**
  *  Description: Whats the purpose of this class
  *
  *
  *
  *
  *
  */
public abstract class DvProcess {

    /**
     *   <p>Description:
     *   </p>
     */
    public abstract DvAddressSpace getAddressSpace();

    /**
     *   <p>Description:
     *   </p>
     */
    public abstract String id();

    /**
     *   <p>Description:
     *   </p>
     */
    public abstract DvThread[] getThreads();

    /**
     *   <p>Description:
     *   </p>
     */
    public abstract boolean isJava();

    /**
     *   <p>Description: Returns the current thread for this process. This is usually
     *                   the most likely candidate for where the problem lies.
     *   </p>
     */
    public abstract DvThread getCurrentThread();

    /**
     *   <p>Description: Returns the current thread for this process. This is usually
     *                   the most likely candidate for where the problem lies.
     *   </p>
     */
    public abstract DvEnvData getEnvData();

    /**
     *   <p>Description: Returns the signal name associated with the failure
     *   </p>
     */
    public abstract String getSignal();

    /**
     *   <p>Description: Returns the current thread for this process. This is usually
     *                   the most likely candidate for where the problem lies.
     *   </p>
     */
    public abstract DvLoaded getLoaded();

    /**
     *   <p>Description:
     *   </p>
     */
    public byte[] getMetaData() { return null; }


}
