/*
 * @(#)src/classes/sov/com/ibm/jvm/dump/DvReader.java, ras, dumpviewer 1.2
 * @(#)DvMemRanges.java, ras, dumpviewer 1.5
 * ===========================================================================
 * IBM Confidential
 * OCO Source Materials
 *
 * IBM Java(tm)2 SDK, Standard Edition, v 1.3.1
 * (C) Copyright IBM Corp. 1998, 2001.
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright office.
 * ===========================================================================
 */

/*
 *
 * ===========================================================================
 *
 *
 *
 * ===========================================================================
 * Change activity:
 *
 * Reason  Date   Origin  Description
 * ------  ----   ------  ----------------------------------------------------
 * 41452  210502 nmasson  New

 *
 * ===========================================================================
 * Module Information:
 *
 * DESCRIPTION:
 * ===========================================================================
 */
package com.ibm.jvm.dump;


 /**
  *  DvReader is an abstract class implementing random
  *  access to data in the address space for a process.  It encapsulates
  *  the knowledge of how the data is organised in memory in terms of
  *  word length and big or little endianness and the size of pointers
  *
  */
import java.io.*;

abstract class DvReader {

/** 
 *  represents the endianness of the data
 */
    WordType endType;		// Big or little end
/** 
 *  holds the wordlength of the data
 */
    WordLength wordLength;	// 32 or 64 bit
/** 
 *  the current read position in the data
 */
    long position;		// Current position in stream

/**
 * reads a byte array from the current offset and moves to the next
 * position
 */
    abstract void read(byte[] b) throws IOException; 
/**
 * reads a byte array from the given offset and moves to the next
 * position
 */
    abstract void read(byte[] b, int off, int len) throws IOException;
}
