/*
 * @(#)src/classes/sov/com/ibm/jvm/dump/Dvifm.java, ras, dumpviewer 1.8
 * ===========================================================================
 * IBM Confidential
 * OCO Source Materials
 *
 * IBM Java(tm)2 SDK, Standard Edition, v 1.3.1
 * (C) Copyright IBM Corp. 1998, 2001.
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright office.
 * ===========================================================================
 */

/*
 *
 * ===========================================================================
 *
 *
 *
 * ===========================================================================
 * Change activity:
 *
 * Reason  Date   Origin  Description
 * ------  ----   ------  ----------------------------------------------------
 * 36524  020502  PHILR:  New for feature 36524
 * 36524  140502  philr   Set up plugin menu item
 * 36524  180702 mpartrid Added 2 more AddContentToFrame methods.
 *
 * ===========================================================================
 * Module Information:
 *
 * DESCRIPTION:
 * ===========================================================================
 */

package com.ibm.jvm.dump;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;


import javax.swing.filechooser.*;
import java.io.*;
import java.util.*;

 /**
  *  Description: Whats the purpose of this class
  *
  *
  *
  *
  *
  */
public class Dvifm extends JFrame {

  private Vector iFrames = new Vector();
  private JInternalFrame[] iframe;
  private JScrollPane[] pane;
  private JSplitPane[] splitpane;
  private int iframecount;
  private int iframeType[];

  private boolean[] iframeUsed;
  private int[] iframeParent; // who's considered the parent of this window.....
  private int[] iframeProperties;   // what is supported by this
  private int activeframe = -1;
  private int iframemax;
  private int submenuIndicator;      // 0 means no submenu up
                                     // anything else indicates what submenu is up and about
  private JPopupMenu[] popupmenu;
  private JTable[] jtable;
  public JTextArea[] jtext;
  public JTree[] jtree;
  private String[] iframeTitle;
  public int trace_iframe = -1;


  //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  // Constructor
  //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 /**
  *   <p>Description:
  *   </p>
  *   <p>Input      :
  *   </p>
  *   <p>Returned   :
  *   </p>
  */
  public Dvifm(int n) {
    iframecount = 0;
    iframemax = n;
    iframe = new JInternalFrame[n];
    iframeUsed = new boolean[n];
    iframeParent = new int[n];
    iframeTitle = new String[n];
    iframeType = new int[n];
    iframeProperties  = new int[n];
    pane = new JScrollPane[n];
    splitpane = new JSplitPane[n];
    popupmenu = new JPopupMenu[n];
    jtable = new JTable[n];
    jtext = new JTextArea[n];
    jtree = new JTree[n];


  }

  //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  // getJTable -
  //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 /**
  *   <p>Description:
  *   </p>
  *   <p>Input      :
  *   </p>
  *   <p>Returned   :
  *   </p>
  */
  public JTable getJTable(int frame) {
    return jtable[frame];
  }


  //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  // createNewFrame - this will create a new iFrame with properties and a frame
  // type and return index to the caller, who can then do things with it.
  //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 /**
  *   <p>Description:
  *   </p>
  *   <p>Input      :
  *   </p>
  *   <p>Returned   :
  *   </p>
  */
  public JInternalFrame createNewFrame(String title,int properties, int frameType) {
      int retval = -1;
      boolean isRESIZEABLE = false;
      boolean isCLOSEABLE  = false;
      boolean isMAXIMIZEABLE = false;
      boolean isICONIFIABLE = false;
      DvifmFrame theFrame = null;

      int p = properties;
      if (p >= DvConstants.FRAME_IS_ICONIFIABLE) {
        isICONIFIABLE = true;
        p = p - DvConstants.FRAME_IS_ICONIFIABLE;
      }
      if (p >= DvConstants.FRAME_IS_MAXIMIZEABLE) {
        isMAXIMIZEABLE = true;
        p = p - DvConstants.FRAME_IS_MAXIMIZEABLE;
      }
      if (p >= DvConstants.FRAME_IS_CLOSEABLE) {
        isCLOSEABLE = true;
        p = p - DvConstants.FRAME_IS_CLOSEABLE;
      }
      if (p >= DvConstants.FRAME_IS_RESIZEABLE) {
        isRESIZEABLE = true;
        p = p - DvConstants.FRAME_IS_RESIZEABLE;
      }

      // we look through the iframeUsed array to find a good slot
      // if there isn't one (i.e. iframecount is MAX_IFRAME_COUNT
      // then we return -1

      // we use the type to set up what basic pieces should go inside our
      // Noe that all our frames are scroll frames, but that some will have
      // tables inside them, some split panels, some JTabPanels etc...
      // assume no space to begin with

      for (int i=0;retval == -1 && i<iframemax ;i++) {
        if (iframeUsed[i] == false) retval = i;

      }


      if (retval != -1) {
        iframeUsed[retval] = true;
        iframeTitle[retval] = title;

        iframecount++;


       // iframe[retval]
       //      = new JInternalFrame(title,
       //                      isRESIZEABLE, isCLOSEABLE,
       //                      isMAXIMIZEABLE, isICONIFIABLE);

        theFrame = new DvifmFrame(title,properties,frameType);
        //x.iframe = iframe[retval];
       // iframe[retval] = theFrame.iframe;
        iFrames.add(theFrame);

        if (frameType == DvConstants.FRAMETYPE_IS_STATUSLINE)
        {
          // for a status line we do not want a header
          // Note this has the added benefit that the status line is non moveable
          javax.swing.plaf.InternalFrameUI ui = theFrame.iframe.getUI();
          ((javax.swing.plaf.basic.BasicInternalFrameUI) ui).setNorthPane(null);

        }

        theFrame.iframe.addInternalFrameListener(new IframeListener());
        popupmenu[retval] = new JPopupMenu();



      }
      else {
      }

    iframeType[retval]=frameType;

    if (frameType == DvConstants.FRAMETYPE_IS_TRACE) trace_iframe = retval;


    return theFrame.iframe;

  }

 /**
  *   <p>Description:
  *   </p>
  *   <p>Input      :
  *   </p>
  *   <p>Returned   :
  *   </p>
  */
  public void setIFrameSelected(JInternalFrame jif) {

      try {
        // if frame is iconized then uniconize it
        if (jif.isIcon() == true) {
          //System.out.println("\nframe is iconized "+i);
         jif.setIcon(false);
        }

       jif.setSelected(true);
      }
      catch (java.beans.PropertyVetoException pve) {
      }
  }

  public String getIframeTitle(int i) {
    return  iframeTitle[i];
  }

  public int getNextIFrame(int where) {
    int nextone = -1;

    for (int i=where+1;  i<iframemax ;i++) {
        if (iframeUsed[i] == true) {
          nextone = i;
          i = iframemax;

        }

    }

    return nextone;
  }



  //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  // removeIFrame - this will remove an iFrame given its id
  //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 /**
  *   <p>Description:
  *   </p>
  *   <p>Input      :
  *   </p>
  *   <p>Returned   :
  *   </p>
  */
  public void  removeIFrame(JInternalFrame jif, boolean sendclose) {

    // If its tc or wm then send the Iframe a close command
    if (sendclose == true)
            jif.doDefaultCloseAction();

    // iframe[fid] = null;
    //iframeUsed[fid]  = false;
    //iframecount--;
    //???if (iframeType[fid] == DvConstants.FRAMETYPE_IS_TRACE) trace_iframe = -1;

    //iframeType[fid] = -1;

  }

  //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  // removeIFrame - this will remove an iFrame given its jif
  //  - if it has child frames it will get rid of them as well
  //
  //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 /**
  *   <p>Description:
  *   </p>
  *   <p>Input      :
  *   </p>
  *   <p>Returned   :
  *   </p>
  */
  public void  removeIFrame(JInternalFrame jif) {
   // figure out frame id
  // int fid = -1 ;

    this.removeIFrame(jif,false);

  }

 /**
  *   <p>Description:
  *   </p>
  *   <p>Input      :
  *   </p>
  *   <p>Returned   :
  *   </p>
  */
  public void addPopupMenuItemToFrame(JInternalFrame i,JMenuItem pmenuItem) {

   //popupmenu[i].add(pmenuItem);
  }

  // Give us an index and we'll give you the frame
 /**
  *   <p>Description:
  *   </p>
  *   <p>Input      :
  *   </p>
  *   <p>Returned   :
  *   </p>
  */
  public JInternalFrame getJInternalFrame(int index) {
     return iframe[index];
  }

  // There wil be lots of these for differing types of
  // content.........
 /**
  *   <p>Description:
  *   </p>
  *   <p>Input      :
  *   </p>
  *   <p>Returned   :
  *   </p>
  */
  public void addContentToFrame(JInternalFrame jif,JTextArea text) {

     DvifmFrame dvifmFrame = findDvifmFrame(jif);
     if (dvifmFrame == null) {
       System.out.println(" Error no dvifmFrame!!!!!");
     }

     dvifmFrame.pane= new JScrollPane(text);
     GenericCaretListener gcl =  new GenericCaretListener();
     //gcl.setOwner(i); //so we know who's listener this is
     text.addCaretListener(gcl);
     dvifmFrame.iframe.getContentPane().setLayout(new BorderLayout());
     dvifmFrame.iframe.setPreferredSize(new Dimension(300,300));
     dvifmFrame.iframe.getContentPane().add("Center", dvifmFrame.pane);
     dvifmFrame.jtext = text;
  }

 /**
  *   <p>Description:
  *   </p>
  *   <p>Input      :
  *   </p>
  *   <p>Returned   :
  *   </p>
  */
  public void addContentToFrame(JInternalFrame jif,JTree tree) {

     DvifmFrame dvifmFrame = findDvifmFrame(jif);
     if (dvifmFrame == null) {
       System.out.println(" Error no dvifmFrame!!!!!");
     }
     dvifmFrame.jtree = tree;
     dvifmFrame.pane= new JScrollPane(tree);
     dvifmFrame.iframe.getContentPane().setLayout(new BorderLayout());
     dvifmFrame.iframe.setPreferredSize(new Dimension(300,300));
     dvifmFrame.iframe.getContentPane().add("Center", dvifmFrame.pane);
  }

 /**
  *   <p>Description:
  *   </p>
  *   <p>Input      :
  *   </p>
  *   <p>Returned   :
  *   </p>
  */
  public void addContentToFrame(JInternalFrame jif,JTable table) {

     DvifmFrame dvifmFrame = findDvifmFrame(jif);
     if (dvifmFrame == null) {
       System.out.println(" Error no dvifmFrame!!!!!");
     }
     dvifmFrame.jtable = table;
     GenericMouseListener gml =  new GenericMouseListener();
     //gml.setOwner(i); //so we know who's listener this is
     table.addMouseListener(gml);


     table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
     //table.addListSelectionListener(new GenericListSelectionListener());

     dvifmFrame.pane= new JScrollPane(table,JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
                              JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
     dvifmFrame.iframe.getContentPane().setLayout(new BorderLayout());
     dvifmFrame.iframe.setPreferredSize(new Dimension(300,300));
     dvifmFrame.iframe.getContentPane().add("Center", dvifmFrame.pane);
  }

 /**
  *   <p>Description:
  *   </p>
  *   <p>Input      :
  *   </p>
  *   <p>Returned   :
  *   </p>
  */
  // This one is special case for a split pane with two scrollable internal panes
  // within it - first is a table, second is non editabe JTextArea - this will
  // typically be used by the asid-process-thread table and gebneric dump indfromation area
  // (the non closeable window at the top)
  public void addContentToFrame(JInternalFrame i,JTable table, JTextArea text) {
     DvifmFrame dvifmFrame = findDvifmFrame(i);
     if (dvifmFrame == null) {
       System.out.println(" Error no dvifmFrame!!!!!");
     }
     GenericMouseListener gml =  new GenericMouseListener();
     GenericCaretListener gcl =  new GenericCaretListener();
     //gcl.setOwner(i); //so we know who's listener this is
     //gml.setOwner(i); //so we know who's listener this is
     text.addCaretListener(gcl);
     table.addMouseListener(gml);
     table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
     //table.addListSelectionListener(new GenericListSelectionListener());
     JScrollPane pane_text =  new JScrollPane(text);
     JScrollPane pane_table = new JScrollPane(table,JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
                              JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);


     dvifmFrame.splitpane= new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,pane_table,pane_text);
     dvifmFrame.splitpane.setOneTouchExpandable(true);
     dvifmFrame.splitpane.setDividerLocation(250);
     Dimension minsize = new Dimension(100,50);
     pane_table.setMinimumSize(minsize);
     pane_text.setMinimumSize(minsize);

     dvifmFrame.iframe.getContentPane().setLayout(new BorderLayout());
     dvifmFrame.iframe.setPreferredSize(new Dimension(300,300));
     dvifmFrame.iframe.getContentPane().add("Center",  dvifmFrame.splitpane);
  }

 /**
  *   <p>Description:
  *   </p>
  *   <p>Input      :
  *   </p>
  *   <p>Returned   :
  *   </p>
  */
    public void addContentToFrame(JInternalFrame i , JTable table, String s) {

     DvifmFrame dvifmFrame = findDvifmFrame(i);
     if (dvifmFrame == null) {
       System.out.println(" Error no dvifmFrame!!!!!");
     }

     dvifmFrame.jtable = table;
     dvifmFrame.jtext =  new JTextArea(s,8,25);
     GenericMouseListener gml =  new GenericMouseListener();
     GenericCaretListener gcl =  new GenericCaretListener();
     //gml.setOwner(i); //so we know who's listener this is
     //gcl.setOwner(i); //so we know who's listener this is

     dvifmFrame.jtext.addCaretListener(gcl);
     table.addMouseListener(gml);
     table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
     //table.addListSelectionListener(new GenericListSelectionListener());
     JScrollPane pane_text =  new JScrollPane(dvifmFrame.jtext);
     JScrollPane pane_table = new JScrollPane(dvifmFrame.jtable,JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
                              JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
     dvifmFrame.splitpane= new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,pane_table,pane_text);
     dvifmFrame.splitpane.setOneTouchExpandable(true);
     dvifmFrame.splitpane.setDividerLocation(250);
     Dimension minsize = new Dimension(100,50);
     pane_table.setMinimumSize(minsize);
     pane_text.setMinimumSize(minsize);

     dvifmFrame.iframe.getContentPane().setLayout(new BorderLayout());
     dvifmFrame.iframe.setPreferredSize(new Dimension(300,300));
     dvifmFrame.iframe.getContentPane().add("Center", dvifmFrame.splitpane);
  }

 /**
  *   <p>Description: Adds a text area and a JPanel to an internal frame.
  *   </p>
  *   <p>Input      :  Internal Frame object, text area and a panel
  *   </p>
  *   <p>Returned   : Nothing
  *   </p>
  */
  public void addContentToFrame(JInternalFrame jif,JTextArea text, JPanel panel) {

     DvifmFrame dvifmFrame = findDvifmFrame(jif);
     if (dvifmFrame == null) {
       System.out.println(" Error no dvifmFrame!!!!!");
     }

     dvifmFrame.pane= new JScrollPane(text);
     GenericCaretListener gcl =  new GenericCaretListener();
     //gcl.setOwner(i); //so we know who's listener this is
     text.addCaretListener(gcl);
     dvifmFrame.iframe.getContentPane().setLayout(new BorderLayout());
     dvifmFrame.iframe.setPreferredSize(new Dimension(300,300));
     dvifmFrame.iframe.getContentPane().add("Center", dvifmFrame.pane);
     dvifmFrame.jtext = text;

     dvifmFrame.mainPanel = panel;
     dvifmFrame.iframe.getContentPane().add("South", dvifmFrame.mainPanel);
  }

 /**
  *   <p>Description: Adds 2 JPanels to an internal frame. One is intended
  *                   to be the main panel and one is intended to just
  *                   be a container to hold buttons for the frame.
  *   </p>
  *   <p>Input      :  Internal Frame object, text main panel and button panel.
  *   </p>
  *   <p>Returned   : Nothing
  *   </p>
  */
  public void addContentToFrame(JInternalFrame jif, JPanel mainPanel, JPanel buttonPanel) {

     DvifmFrame dvifmFrame = findDvifmFrame(jif);
     if (dvifmFrame == null) {
       System.out.println(" Error no dvifmFrame!!!!!");
     }

     dvifmFrame.mainPanel = mainPanel;
     dvifmFrame.iframe.getContentPane().setLayout(new BorderLayout());
     dvifmFrame.iframe.setPreferredSize(new Dimension(300,300));
     dvifmFrame.iframe.getContentPane().add("Center", dvifmFrame.mainPanel);

     dvifmFrame.jButtonPanel = buttonPanel;
     dvifmFrame.iframe.getContentPane().add("South", dvifmFrame.jButtonPanel);
  }

 /**
  *   <p>Description: Adds a single JPanels to an internal frame. This can be used
  *                   a container to hold any other components
  *   </p>
  *   <p>Input      :  Internal Frame object and panel.
  *   </p>
  *   <p>Returned   : Nothing
  *   </p>
  */
  public void addContentToFrame(JInternalFrame jif, JPanel panel ) {

     DvifmFrame dvifmFrame = findDvifmFrame(jif);
     if (dvifmFrame == null) {
       System.out.println(" Error no dvifmFrame!!!!!");
     }

     dvifmFrame.mainPanel = panel;
     dvifmFrame.iframe.getContentPane().setLayout(new BorderLayout());
     dvifmFrame.iframe.setPreferredSize(new Dimension(300,300));
     dvifmFrame.iframe.getContentPane().add("Center", dvifmFrame.mainPanel);
  }

 /**
  *   <p>Description:
  *   </p>
  *   <p>Input      :
  *   </p>
  *   <p>Returned   :
  *   </p>
  */
  public int getDefaultProperties() {
   return(DvConstants.FRAME_IS_ICONIFIABLE +
          DvConstants.FRAME_IS_MAXIMIZEABLE +
          DvConstants.FRAME_IS_CLOSEABLE +
          DvConstants.FRAME_IS_RESIZEABLE);
  }

 /**
  *   <p>Description:
  *   </p>
  *   <p>Input      :
  *   </p>
  *   <p>Returned   :
  *   </p>
  */
  // orphaniseFrame - this will take a frame to the top of the
  // parent child hierarchy, so that you can close a great deal of the hierarchy and
  // leave this frame around.
  public void orphaniseFrame(int frame_id) {

  }

 /**
  *   <p>Description:
  *   </p>
  *   <p>Input      :
  *   </p>
  *   <p>Returned   :
  *   </p>
  */
  private int findWhatFrame(InternalFrameEvent iFE)
  {
    boolean foundit = false;
    int i;

    for (i=0;i<iframemax && foundit == false; i++)
    {
      if (iframeUsed[i] == true) {
        if (iFE.getInternalFrame() == iframe[i]) {
          // System.out.println("\nmatch found ... " + i);
          foundit=true;

        }
      }
    }
    i = i-1;
    if (foundit == false) i=-1;
    return i;
  }




  class IframeListener implements InternalFrameListener {

       public void internalFrameActivated(javax.swing.event.InternalFrameEvent internalFrameEvent) {
       }


       public void internalFrameDeiconified(javax.swing.event.InternalFrameEvent internalFrameEvent) {

       }

       public void internalFrameDeactivated(javax.swing.event.InternalFrameEvent internalFrameEvent) {
       }

       public void internalFrameOpened(javax.swing.event.InternalFrameEvent internalFrameEvent) {
       }

       public void internalFrameIconified(javax.swing.event.InternalFrameEvent internalFrameEvent) {
       }

       public void internalFrameClosing(javax.swing.event.InternalFrameEvent internalFrameEvent) {
         int i = findWhatFrame(internalFrameEvent);
         if (i == -1) {
           // something screwy
         }
         else
         {
           //????removeIFrame(i,false);
         }
       }

       public void internalFrameClosed(javax.swing.event.InternalFrameEvent internalFrameEvent) {

       }

   }

  class GenericActionListener implements ActionListener {
     public void actionPerformed(ActionEvent e) {

     }
  }

  class GenericCaretListener implements CaretListener {

    private int whatIframe; // who owns me!


     public void setOwner(int i) {
       whatIframe = i;
     }

     public void caretUpdate(CaretEvent e) {
        //System.out.println("\n"+e.toString());

        //int pos = jtext[whatIframe].getCaretPosition();
        //System.out.println("\nPos " + pos);
        //System.out.println("\nCaret Listener invoked for window " + whatIframe);
        //System.out.println("\nCaret x " + caretCoords.x);
        //System.out.println("\nCaret y " + caretCoords.y);
     }

  }

  class GenericMouseListener implements MouseListener {
     private int whatIframe; // who owns me!


     public void setOwner(int i) {
       whatIframe = i;
     }

     public void mouseClicked(MouseEvent e) {
       // If it was the right mouse button and there is a selection active on
       // the component then we display the sub menu and then wait for either
       // a mouse click off or on the submenu. If its on then we activate the
       // chosen action...... if its off then we remove the submenu.
       // If it was a left mouse button then we check to see if theres another
       // window to launch - depends on the type of display
       System.out.println("\nwow we have detected a mouse click");
       System.out.println("\n and i is "+whatIframe);

       // Is it a right mouse click? rather than a left mouse click?
       // find what internal frame is doing the clicking....... assume that its the
       // active one........
       // and pick up the correct popup menu (if it exists) ... ignore if it doesn't
       // Lets figure out whether its the right mouse button or the left one
       // and whether its a double click....
       int numClicks= e.getClickCount();
       System.out.println("\n and numclicks is "+ numClicks);
       if ((e.getModifiers() & InputEvent.BUTTON3_MASK)== InputEvent.BUTTON3_MASK)
       {
           System.out.println("\n its the right mouse button");

          if (popupmenu[whatIframe] != null) {
               popupmenu[whatIframe].show(e.getComponent(),
                          e.getX(),e.getY());
          }
          else {
             System.out.println("\n no popup menu defined with this one");
          }
       }
       else
       {
         System.out.println("\n its the left mouse button");
         // Its the left mouse button - if its a double click then we possibly need to
         // launch something......................................

       }

     }
     public void mousePressed(MouseEvent e) {


     }
     public void mouseReleased(MouseEvent e) {

     }
     public void mouseEntered(MouseEvent e) {

     }
     public void mouseExited(MouseEvent e) {

     }
  }

  class GenericListSelectionListener implements ListSelectionListener {
     public void valueChanged(ListSelectionEvent e) {
       System.out.println("\nwow we have detected a ListSelectionEvent");

     }
  }


 /**
  *   <p>Description:
  *   </p>
  *   <p>Input      :
  *   </p>
  *   <p>Returned   :
  *   </p>
  */
  public DvifmFrame findDvifmFrame(String s) {

      DvifmFrame found=null ;

      for (int i=0;i<iFrames.size();i++) {

        found = (DvifmFrame) iFrames.get(i);
        if (found.iframeTitle.equals(s)) return found;

      }

    return null;
  }

 /**
  *   <p>Description:
  *   </p>
  *   <p>Input      :
  *   </p>
  *   <p>Returned   :
  *   </p>
  */
  public DvifmFrame findDvifmFrame(JInternalFrame f) {

      DvifmFrame found=null ;

      for (int i=0;i<iFrames.size();i++) {

        found = (DvifmFrame) iFrames.get(i);
        if (found.iframe == f) return found;

      }

    return null;
  }

 /**
  *   <p>Description:
  *   </p>
  *   <p>Input      :
  *   </p>
  *   <p>Returned   :
  *   </p>
  */
  public JTable findTable(JInternalFrame f) {

      DvifmFrame found=null ;

      for (int i=0;i<iFrames.size();i++) {

        found = (DvifmFrame) iFrames.get(i);
        if (found.iframe == f) return found.jtable;

      }

    return null;
  }

 /**
  *   <p>Description:
  *   </p>
  *   <p>Input      :
  *   </p>
  *   <p>Returned   :
  *   </p>
  */
  public JTree findTree(JInternalFrame f) {

      DvifmFrame found=null ;

      for (int i=0;i<iFrames.size();i++) {

        found = (DvifmFrame) iFrames.get(i);
        if (found.iframe == f) return found.jtree;

      }

    return null;
  }

 /**
  *   <p>Description:
  *   </p>
  *   <p>Input      :
  *   </p>
  *   <p>Returned   :
  *   </p>
  */
 public Enumeration getIFrameElements() {
   return iFrames.elements();
 }

 /**
  *   <p>Description: The details of the various command plugins and the
  *                   commands that they support are held in the DvConsole
  *                   instance we go through each one and create a plugin
  *                   menu, submenus and items.
  *   </p>
  */
 public void addPluginMenuItem(DvConsole dvConsole) {

     //Vector commandPlugins = dvConsole.getCPVector();

     // So we go through each Command Plugin and ask it what it
     // wants to use as a submenu, then we ask it for those things
     // it wants under the sub menu... each one should have a type
     // which indicates whether its simple "straight command" format
     // or whether its using the more complicated callback
     // mechanism....
     // into a listener that the plugin will have activated.....

 }


}


