/*
 * @(#)src/classes/sov/com/ibm/jvm/dump/Elf.java, ras, dumpviewer 1.2
 * ===========================================================================
 * IBM Confidential
 * OCO Source Materials
 *
 * IBM Java(tm)2 SDK, Standard Edition, v 1.3.1
 * (C) Copyright IBM Corp. 1998, 2001.
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright office.
 * ===========================================================================
 */

/*
 *
 * ===========================================================================
 *
 *
 *
 * ===========================================================================
 * Change activity:
 *
 * Reason  Date   Origin  Description
 * ------  ----   ------  ----------------------------------------------------
 * 41452  210502 nmasson  New

 *
 * ===========================================================================
 * Module Information:
 *
 * DESCRIPTION:
 * ===========================================================================
 */
package com.ibm.jvm.dump;


 /**
  * Encapsulates the Elf file format
  */

import java.io.*;

class Elf extends Layout {
    DvFileReader getFileReader(RandomAccessFile core) throws IOException {
	WordLength wordLength;
	WordType  wordType;
	byte[] buf = new byte[2];
	core.seek(4);
	core.read(buf);
	switch (buf[0]) {
	    case 1:
		DvUtils.trace("32 bits", 2, false);
		wordLength = new WordLength(32);
		break;
	    case 2:
		DvUtils.trace("64 bits", 2, false);
		wordLength = new WordLength(64);
		break;
	    default:
		throw new IOException("Bad length");
	}
	switch (buf[1]) {
	    case 1:
		DvUtils.trace("Little end", 2, false);
		wordType = new LittleEnd();
		break;
	    case 2:
		DvUtils.trace("Big end", 2, false);
		wordType = new BigEnd();
		break;
	    default:
		throw new IOException("Bad type");
	}
	return new DvFileReader(core, wordType, wordLength);
    }
    SDFFDump readHeader(DvReader reader) throws IOException {
	DvUtils.trace("Create Elf Header", 2, false);
	return(new ElfHeader((DvFileReader)reader));
    }
    MemoryMap readSegments(DvFileReader reader, SDFFDump header) 
	throws IOException {
	DvUtils.trace("Read Elf Segments", 2, false);
	LinuxMemoryMap m = new LinuxMemoryMap(reader, (ElfHeader)header);
	return(m);
    }
}
