/*
 * @(#)src/classes/sov/com/ibm/jvm/dump/ElfHeader.java, ras, dumpviewer 1.2
 * ===========================================================================
 * IBM Confidential
 * OCO Source Materials
 *
 * IBM Java(tm)2 SDK, Standard Edition, v 1.3.1
 * (C) Copyright IBM Corp. 1998, 2001.
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright office.
 * ===========================================================================
 */

/*
 *
 * ===========================================================================
 *
 *
 *
 * ===========================================================================
 * Change activity:
 *
 * Reason  Date   Origin  Description
 * ------  ----   ------  ----------------------------------------------------
 * 41452  210502 nmasson  New

 *
 * ===========================================================================
 * Module Information:
 *
 * DESCRIPTION:
 * ===========================================================================
 */
package com.ibm.jvm.dump;


 /**
  * Encapsulates the Elf file header
  */

import java.io.*;

class ElfHeader extends SDFFDump {
	long endian;
	long wordLength;
	long type;
	long machine;
	long version;
	long entry;
	long programHeaderOffset;
	long sectionHeaderOffset;
	long flags;
	long elfHeaderSize;
	long programHeaderEntrySize;
	long numProgramHeaders;
	long sectionHeaderEntrySize;
	long numSectionHeaders;
	long stringTable;
    
    ElfHeader(DvFileReader reader) throws IOException {
//	super();
	reader.setPos(16);
	//long Id = reader.readWord();
	//Endian = reader.readChar();
	//WordLength = reader.readChar();
        type = reader.readHalf();
        machine = reader.readHalf();
        version = reader.readWord();
        entry = reader.readAddress();
        programHeaderOffset = reader.readAddress();
        sectionHeaderOffset = reader.readAddress();
        flags = reader.readWord();
        elfHeaderSize = reader.readHalf();
        programHeaderEntrySize = reader.readHalf();
        numProgramHeaders = reader.readHalf();
        sectionHeaderEntrySize = reader.readHalf();
        numSectionHeaders = reader.readHalf();
        stringTable = reader.readHalf();

	// Fill in the fields for the standard header
	system = SYSTEM_IS_LINUX;
	setArchitecture(reader.wordLength, reader.endType);
	subsystem =  SUBSYS_SUSE;
	switch((int)machine) {
	    case 3:
		processor = PROCESSOR_IS_INTEL;
		break;
	    case 20:
		processor = PROCESSOR_IS_PPC;
		break;
	    case 21:
		// 64 bit PPC
		processor = PROCESSOR_IS_PPC;
		break;
	    case 2:
		//processor = PROCESSOR_IS_SPARC;
		processor = PROCESSOR_IS_UNKNOWN;
		break;
	    case 9:
		//processor = PROCESSOR_IS_390;
		processor = PROCESSOR_IS_UNKNOWN;
		break;
	    default:
		processor = PROCESSOR_IS_UNKNOWN;
		break;
	}
    }
    void dump() throws IOException {
	DvUtils.trace("ELF Header Info", 2, false);
        DvUtils.trace("Type = " + type, 2, false);
        DvUtils.trace("Machine = " + machine, 2, false);
        DvUtils.trace("Version = " + version, 2, false);
        DvUtils.trace("Entry = " + entry, 2, false);
        DvUtils.trace("ProgramHeaderOffset = " + 
	    Long.toHexString(programHeaderOffset), 2, false);
        DvUtils.trace("SectionHeaderOffset = " + sectionHeaderOffset, 2, false);
        DvUtils.trace("Flags = " + 
	     Long.toHexString(flags), 2, false);
        DvUtils.trace("EHSize = " + 
	     Long.toHexString(elfHeaderSize), 2, false);
        DvUtils.trace("ProgramHeaderEntrySize = " + 
	     Long.toHexString(programHeaderEntrySize), 2, false);
        DvUtils.trace("NumProgramHeaders = " + numProgramHeaders, 2, false);
        DvUtils.trace("SectionHeaderEntrySize = " + 
	     Long.toHexString(sectionHeaderEntrySize), 2, false);
        DvUtils.trace("NumSectionHeaders = " + numSectionHeaders, 2, false);
        DvUtils.trace("StringTable = " + 
	     Long.toHexString(stringTable), 2, false);
    }
}
