/*
 * @(#)src/classes/sov/com/ibm/jvm/dump/ElfNote.java, ras, dumpviewer 1.6    
 * ===========================================================================
 * IBM Confidential
 * OCO Source Materials
 *
 * IBM Java(tm)2 SDK, Standard Edition, v 1.3.1
 * (C) Copyright IBM Corp. 1998, 2001.
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright office.
 * ===========================================================================
 */

/*
 *
 * ===========================================================================
 *
 *
 *
 * ===========================================================================
 * Change activity:
 *
 * Reason  Date   Origin  Description
 * ------  ----   ------  ----------------------------------------------------
 * 41452  210502 nmasson  New

 *
 * ===========================================================================
 * Module Information:
 *
 * DESCRIPTION:
 * ===========================================================================
 */
package com.ibm.jvm.dump;

import java.io.*;
import java.util.*;

 /**
  * ElfNote reads Notes sections in a Linux core file
  * The layout is derived from the kernel files
  * /usr/src/linux/include/linux/elfcore.h
  * /usr/src/linux/fs/binfmt_elf.c
  */
import java.util.*;
import java.io.*;

class ElfNote {
    Long pid;
    HashMap register = new HashMap();
    int signal;

    ElfNote() throws IOException {
    }

    ElfNote(DvFileReader fileReader) throws IOException {
	long signo = fileReader.readWord();
	long code = fileReader.readWord();
	long errno = fileReader.readWord();
	long cursig = fileReader.readHalf();
	long dummy = fileReader.readHalf();
	long pending = fileReader.readAddress();
	long blocked = fileReader.readAddress();
	long pid = fileReader.readWord();
	long ppid = fileReader.readWord();
	long pgroup = fileReader.readWord();
	long session = fileReader.readWord();

	long utime_sec = fileReader.readWord();
	long utime_usec = fileReader.readWord();

	long stime_sec = fileReader.readWord();
	long stime_usec = fileReader.readWord();

	long cutime_sec = fileReader.readWord();
	long cutime_usec = fileReader.readWord();

	long cstime_sec = fileReader.readWord();
	long cstime_usec = fileReader.readWord();

	DvUtils.trace("signo = " + signo, 2, false);
	DvUtils.trace("code = " + code, 2, false);
	DvUtils.trace("errno = " + errno, 2, false);
	DvUtils.trace("cursig = " + cursig, 2, false);
	DvUtils.trace("pending = " + Long.toHexString(pending), 2, false);
	DvUtils.trace("blocked = " + Long.toHexString(blocked), 2, false);
	DvUtils.trace("pid = " + pid, 2, false);
	DvUtils.trace("ppid = " + ppid, 2, false);
	DvUtils.trace("pgroup = " + pgroup, 2, false);
	DvUtils.trace("session = " + session, 2, false);

	DvUtils.trace("utime = " + utime_sec + "." + utime_usec, 2, false);
	DvUtils.trace("stime = " + stime_sec + "." + stime_usec, 2, false);
	DvUtils.trace("cutime = " + cutime_sec + "." + cutime_usec, 2, false);
	DvUtils.trace("cstime = " + cstime_sec + "." + cstime_usec, 2, false);

	this.pid = new Long(pid);
	this.signal = (int)cursig;
    }
}    
