/*
 * @(#)src/classes/sov/com/ibm/jvm/dump/ElfNoteIA32.java, ras, dumpviewer 1.2
 * ===========================================================================
 * IBM Confidential
 * OCO Source Materials
 *
 * IBM Java(tm)2 SDK, Standard Edition, v 1.3.1
 * (C) Copyright IBM Corp. 1998, 2001.
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright office.
 * ===========================================================================
 */

/*
 *
 * ===========================================================================
 *
 *
 *
 * ===========================================================================
 * Change activity:
 *
 * Reason  Date   Origin  Description
 * ------  ----   ------  ----------------------------------------------------
 * 41452  210502 nmasson  New

 *
 * ===========================================================================
 * Module Information:
 *
 * DESCRIPTION:
 * ===========================================================================
 */
package com.ibm.jvm.dump;

import java.io.*;
import java.util.*;

 /**
  * ElfNoteIA32s reads Notes sections in a Linux core file
  * The layout is derived from the kernel files
  * /usr/src/linux/include/linux/elfcore.h
  * /usr/src/linux/fs/binfmt_elf.c
  */
import java.util.*;
import java.io.*;

class ElfNoteIA32 extends ElfNote {

    ElfNoteIA32(DvFileReader fileReader) throws IOException {
	// Read the hardware-independent section
	super(fileReader);

	    // Now the registers !
	//Data from /usr/src/linux/include/asm-i386/user.h
	long ebx = fileReader.readWord();
	long ecx = fileReader.readWord();
	long edx = fileReader.readWord();
	long esi = fileReader.readWord();
	long edi = fileReader.readWord();
	long ebp = fileReader.readWord();
	long eax = fileReader.readWord();
	
	long ds  = fileReader.readHalf();
	long __ds  = fileReader.readHalf();
	long es  = fileReader.readHalf();
	long __es  = fileReader.readHalf();
	long fs  = fileReader.readHalf();
	long __fs  = fileReader.readHalf();
	long gs  = fileReader.readHalf();
	long __gs  = fileReader.readHalf();

	long orig_eax = fileReader.readWord();
	long eip = fileReader.readWord();

	long cs  = fileReader.readHalf();
	long __cs  = fileReader.readHalf();

	long eflags = fileReader.readWord();
	long esp = fileReader.readWord();

	long ss  = fileReader.readHalf();
	long __ss  = fileReader.readHalf();

	register.put((Object)"ebx     ", (Object)(new Long(ebx)));
	register.put((Object)"ecx     ", (Object)(new Long(ecx)));
	register.put((Object)"edx     ", (Object)(new Long(edx)));
	register.put((Object)"esi     ", (Object)(new Long(esi)));
	register.put((Object)"edi     ", (Object)(new Long(edi)));
	register.put((Object)"ebp     ", (Object)(new Long(ebp)));
	register.put((Object)"eax     ", (Object)(new Long(eax)));
	register.put((Object)"ds      ", (Object)(new Long(ds) ));
	register.put((Object)"es      ", (Object)(new Long(es) ));
	register.put((Object)"fs      ", (Object)(new Long(fs) ));
	register.put((Object)"gs      ", (Object)(new Long(gs) ));
	register.put((Object)"cs      ", (Object)(new Long(cs) ));
	register.put((Object)"eflags  ", (Object)(new Long(eflags)));
	register.put((Object)"esp     ", (Object)(new Long(esp)));
	register.put((Object)"ss      ", (Object)(new Long(ss) ));
	DvUtils.trace("ebx = " + Long.toHexString(ebx), 2, false);
	DvUtils.trace("ecx = " + Long.toHexString(ecx), 2, false);
	DvUtils.trace("edx = " + Long.toHexString(edx), 2, false);
	DvUtils.trace("esi = " + Long.toHexString(esi), 2, false);
	DvUtils.trace("edi = " + Long.toHexString(edi), 2, false);
	DvUtils.trace("ebp = " + Long.toHexString(ebp), 2, false);
	DvUtils.trace("eax = " + Long.toHexString(eax), 2, false);
	DvUtils.trace("ds = " + Long.toHexString(ds), 2, false);
	DvUtils.trace("__ds = " + Long.toHexString(__ds), 2, false);
	DvUtils.trace("es = " + Long.toHexString(es), 2, false);
	DvUtils.trace("__es = " + Long.toHexString(__es), 2, false);
	DvUtils.trace("fs = " + Long.toHexString(fs), 2, false);
	DvUtils.trace("__fs = " + Long.toHexString(__fs), 2, false);
	DvUtils.trace("gs = " + Long.toHexString(gs), 2, false);
	DvUtils.trace("__gs = " + Long.toHexString(__gs), 2, false);
	DvUtils.trace("orig_eax = " + Long.toHexString(orig_eax), 2, false);
	DvUtils.trace("eip = " + Long.toHexString(eip), 2, false);
	DvUtils.trace("cs = " + Long.toHexString(cs), 2, false);
	DvUtils.trace("__cs = " + Long.toHexString(__cs), 2, false);
	DvUtils.trace("eflags = " + Long.toHexString(eflags), 2, false);
	DvUtils.trace("esp = " + Long.toHexString(esp), 2, false);
	DvUtils.trace("ss = " + Long.toHexString(ss), 2, false);
	DvUtils.trace("__ss = " + Long.toHexString(__ss), 2, false);

	long fpvalid = fileReader.readWord();
	DvUtils.trace("fpvalid" + fpvalid, 2, false);

    }
}
