/*
 * @(#)src/classes/sov/com/ibm/jvm/dump/ElfNoteIA64.java, ras, dumpviewer 1.3
 * ===========================================================================
 * IBM Confidential
 * OCO Source Materials
 *
 * IBM Java(tm)2 SDK, Standard Edition, v 1.3.1
 * (C) Copyright IBM Corp. 1998, 2001.
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright office.
 * ===========================================================================
 */

/*
 *
 * ===========================================================================
 *
 *
 *
 * ===========================================================================
 * Change activity:
 *
 * Reason  Date   Origin  Description
 * ------  ----   ------  ----------------------------------------------------
 * 41452  210502 nmasson  New

 *
 * ===========================================================================
 * Module Information:
 *
 * DESCRIPTION:
 * ===========================================================================
 */
package com.ibm.jvm.dump;

import java.io.*;
import java.util.*;

 /**
  * ElfNoteIA64s reads Notes sections in a Linux core file
  * The layout is derived from the kernel files
  * /usr/src/linux/include/linux/elfcore.h
  * /usr/src/linux/fs/binfmt_elf.c
  * /usr/src/linux-2.4.10.SuSE/include/asm-ia64/ptrace.h
  */
import java.util.*;
import java.io.*;

class ElfNoteIA64 extends ElfNote {

    ElfNoteIA64(DvFileReader fileReader) throws IOException {
	// Read the hardware-independent section
	super(fileReader);

	    // Now the registers !
	//Data from /usr/src/linux/include/asm-i386/user.h
	long cr_ipsr = fileReader.readLong();
	long cr_iip = fileReader.readLong();
	long cr_ifs = fileReader.readLong();
	long ar_unat = fileReader.readLong();
	long ar_pfs = fileReader.readLong();
	long ar_rsc = fileReader.readLong();
	long ar_rnat = fileReader.readLong();
	long ar_bpstore = fileReader.readLong();
	long pr = fileReader.readLong();
	long b6 = fileReader.readLong();
	long loadrs = fileReader.readLong();
	long r1 = fileReader.readLong();
	long r2 = fileReader.readLong();
	long r3 = fileReader.readLong();
	long r12 = fileReader.readLong();
	long r13 = fileReader.readLong();
	long r14 = fileReader.readLong();
	long r15 = fileReader.readLong();
	long r8 = fileReader.readLong();
	long r9 = fileReader.readLong();
	long r10 = fileReader.readLong();
	long r11 = fileReader.readLong();
	long r16 = fileReader.readLong();
	long r17 = fileReader.readLong();
	long r18 = fileReader.readLong();
	long r19 = fileReader.readLong();
	long r20 = fileReader.readLong();
	long r21 = fileReader.readLong();
	long r22 = fileReader.readLong();
	long r23 = fileReader.readLong();
	long r24 = fileReader.readLong();
	long r25 = fileReader.readLong();
	long r26 = fileReader.readLong();
	long r27 = fileReader.readLong();
	long r28 = fileReader.readLong();
	long r29 = fileReader.readLong();
	long r30 = fileReader.readLong();
	long r31 = fileReader.readLong();
	long ar_ccv = fileReader.readLong();
	long ar_fpsr = fileReader.readLong();
	long b0 = fileReader.readLong();
	long b7 = fileReader.readLong();
	long f6 = fileReader.readLong();
	long f7 = fileReader.readLong();
	long f8 = fileReader.readLong();
	long f9 = fileReader.readLong();
	
	register.put((Object)"cr_ipsr ", (Object)(new Long(cr_ipsr)));
	register.put((Object)"cr_iip  ", (Object)(new Long(cr_iip)));
	register.put((Object)"cr_ifs  ", (Object)(new Long(cr_ifs)));
	register.put((Object)"ar_unat ", (Object)(new Long(cr_ifs)));
	register.put((Object)"ar_pfs  ", (Object)(new Long(ar_pfs)));
	register.put((Object)"ar_rsc  ", (Object)(new Long(ar_rsc)));
	register.put((Object)"ar_rnat ", (Object)(new Long(ar_rnat)));
	//IBM.FIXME ar_bpstore
	register.put((Object)"ar_bpsto", (Object)(new Long(ar_bpstore) ));
	register.put((Object)"pr      ", (Object)(new Long(pr) ));
	register.put((Object)"b6      ", (Object)(new Long(b6) ));
	register.put((Object)"loadrs  ", (Object)(new Long(loadrs) ));
	register.put((Object)"r1      ", (Object)(new Long(r1) ));
	register.put((Object)"r2      ", (Object)(new Long(r2)));
	register.put((Object)"r3      ", (Object)(new Long(r3)));
	register.put((Object)"r12     ", (Object)(new Long(r12) ));
	register.put((Object)"r13     ", (Object)(new Long(r13) ));
	register.put((Object)"r14     ", (Object)(new Long(r14) ));
	register.put((Object)"r15     ", (Object)(new Long(r15) ));
	register.put((Object)"r8      ", (Object)(new Long(r9) ));
	register.put((Object)"r9      ", (Object)(new Long(r9) ));
	register.put((Object)"r10     ", (Object)(new Long(r10) ));
	register.put((Object)"r11     ", (Object)(new Long(r11) ));
	register.put((Object)"r16     ", (Object)(new Long(r16) ));
	register.put((Object)"r17     ", (Object)(new Long(r17) ));
	register.put((Object)"r18     ", (Object)(new Long(r18) ));
	register.put((Object)"r19     ", (Object)(new Long(r19) ));
	register.put((Object)"r20     ", (Object)(new Long(r20) ));
	register.put((Object)"r21     ", (Object)(new Long(r21) ));
	register.put((Object)"r22     ", (Object)(new Long(r22) ));
	register.put((Object)"r23     ", (Object)(new Long(r23) ));
	register.put((Object)"r24     ", (Object)(new Long(r24) ));
	register.put((Object)"r25     ", (Object)(new Long(r25) ));
	register.put((Object)"r26     ", (Object)(new Long(r26) ));
	register.put((Object)"r27     ", (Object)(new Long(r27) ));
	register.put((Object)"r28     ", (Object)(new Long(r28) ));
	register.put((Object)"r29     ", (Object)(new Long(r29) ));
	register.put((Object)"r30     ", (Object)(new Long(r30) ));
	register.put((Object)"r31     ", (Object)(new Long(r31) ));
	register.put((Object)"ar_ccv  ", (Object)(new Long(ar_ccv) ));
	register.put((Object)"ar_fpsr ", (Object)(new Long(ar_fpsr) ));
	register.put((Object)"b0      ", (Object)(new Long(b0) ));
	register.put((Object)"b7      ", (Object)(new Long(b7) ));
	register.put((Object)"f6      ", (Object)(new Long(f6) ));
	register.put((Object)"f7      ", (Object)(new Long(f7) ));
	register.put((Object)"f8      ", (Object)(new Long(f8) ));
	register.put((Object)"f9      ", (Object)(new Long(f9) ));

	DvUtils.trace("cr_ipsr " + Long.toHexString(cr_ipsr), 2, false);
	DvUtils.trace("cr_iip = " + Long.toHexString(cr_iip), 2, false);
	DvUtils.trace("cr_ifs = " + Long.toHexString(cr_ifs), 2, false);
	DvUtils.trace("ar_unat = " + Long.toHexString(ar_unat), 2, false);
	DvUtils.trace("ar_pfs = " + Long.toHexString(ar_pfs), 2, false);
	DvUtils.trace("ar_rsc = " + Long.toHexString(ar_rsc), 2, false);
	DvUtils.trace("ar_rnat = " + Long.toHexString(ar_rnat), 2, false);
	DvUtils.trace("ar_bpstore = " + Long.toHexString(ar_bpstore), 2, false);
	DvUtils.trace("pr = " + Long.toHexString(pr), 2, false);
	DvUtils.trace("b6 = " + Long.toHexString(b6), 2, false);
	DvUtils.trace("loadrs = " + Long.toHexString(loadrs), 2, false);
	DvUtils.trace("r1 = " + Long.toHexString(r1), 2, false);
	DvUtils.trace("r2 = " + Long.toHexString(r2), 2, false);
	DvUtils.trace("r3 = " + Long.toHexString(r3), 2, false);
	DvUtils.trace("r12 = " + Long.toHexString(r12), 2, false);
	DvUtils.trace("r13 = " + Long.toHexString(r13), 2, false);
	DvUtils.trace("r14 = " + Long.toHexString(r14), 2, false);
	DvUtils.trace("r15 = " + Long.toHexString(r15), 2, false);
	DvUtils.trace("r8 = " + Long.toHexString(r8), 2, false);
	DvUtils.trace("r9 = " + Long.toHexString(r9), 2, false);
	DvUtils.trace("r10 = " + Long.toHexString(r10), 2, false);
	DvUtils.trace("r11 = " + Long.toHexString(r11), 2, false);
	DvUtils.trace("r16 = " + Long.toHexString(r16), 2, false);
	DvUtils.trace("r17 = " + Long.toHexString(r17), 2, false);
	DvUtils.trace("r18 = " + Long.toHexString(r18), 2, false);
	DvUtils.trace("r19 = " + Long.toHexString(r19), 2, false);
	DvUtils.trace("r20 = " + Long.toHexString(r20), 2, false);
	DvUtils.trace("r21 = " + Long.toHexString(r21), 2, false);
	DvUtils.trace("r22 = " + Long.toHexString(r22), 2, false);
	DvUtils.trace("r23 = " + Long.toHexString(r23), 2, false);
	DvUtils.trace("r24 = " + Long.toHexString(r24), 2, false);
	DvUtils.trace("r25 = " + Long.toHexString(r25), 2, false);
	DvUtils.trace("r26 = " + Long.toHexString(r26), 2, false);
	DvUtils.trace("r27 = " + Long.toHexString(r27), 2, false);
	DvUtils.trace("r28 = " + Long.toHexString(r28), 2, false);
	DvUtils.trace("r29 = " + Long.toHexString(r29), 2, false);
	DvUtils.trace("r30 = " + Long.toHexString(r30), 2, false);
	DvUtils.trace("r31 = " + Long.toHexString(r31), 2, false);

	DvUtils.trace("ar_ccv = " + Long.toHexString(ar_ccv), 2, false);
	DvUtils.trace("ar_fpsr = " + Long.toHexString(ar_fpsr), 2, false);
	DvUtils.trace("b0 = " + Long.toHexString(b0), 2, false);
	DvUtils.trace("b7 = " + Long.toHexString(b7), 2, false);
	DvUtils.trace("f6 = " + Long.toHexString(f6), 2, false);
	DvUtils.trace("f7 = " + Long.toHexString(f7), 2, false);
	DvUtils.trace("f8 = " + Long.toHexString(f8), 2, false);
	DvUtils.trace("f9 = " + Long.toHexString(f9), 2, false);

    }
}
