/*
 * @(#)src/classes/sov/com/ibm/jvm/dump/ElfNotePPC32.java, ras, dumpviewer 1.4
 * ===========================================================================
 * IBM Confidential
 * OCO Source Materials
 *
 * IBM Java(tm)2 SDK, Standard Edition, v 1.3.1
 * (C) Copyright IBM Corp. 1998, 2001.
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright office.
 * ===========================================================================
 */

/*
 *
 * ===========================================================================
 *
 *
 *
 * ===========================================================================
 * Change activity:
 *
 * Reason  Date   Origin  Description
 * ------  ----   ------  ----------------------------------------------------
 * 41452  210502 nmasson  New

 *
 * ===========================================================================
 * Module Information:
 *
 * DESCRIPTION:
 * ===========================================================================
 */
package com.ibm.jvm.dump;

import java.io.*;
import java.util.*;

 /**
  * ElfNotePPC32s reads Notes sections in a Linux core file
  * The layout is derived from the structure pt_regs in
  * /usr/src/linux/include/asm-ppc/ptrace.h
  */
import java.util.*;
import java.io.*;

class ElfNotePPC32 extends ElfNote {

    ElfNotePPC32(DvFileReader fileReader) throws IOException {
	super(fileReader);
	//Data from /usr/src/linux/include/asm-ppc/ptrace.h
	long gpr;
	String pad = "    ";
	for(int i=1; i<33; i++) {
		gpr = fileReader.readWord();
		String regName = "gpr"+ Long.toString(i) + pad;
		DvUtils.trace(regName + " = " + Long.toHexString(gpr), 2, false);
		register.put((Object)regName, (Object)(new Long(gpr)));
		if(i == 9) {
		pad = "   ";
		}
	}
	long nip = fileReader.readWord();
	long msr = fileReader.readWord();
	long origgpr3 = fileReader.readWord();
	long ctr = fileReader.readWord();
	long link = fileReader.readWord();
	long xer = fileReader.readWord();
	long ccr = fileReader.readWord();
	long mq  = fileReader.readWord();
	long trap  = fileReader.readWord();
	long dar  = fileReader.readWord();
	long dsisr  = fileReader.readWord();
	long result  = fileReader.readWord();
	//IBM.FIXME find out what the other four registers are
	long q1  = fileReader.readWord();
	long q2  = fileReader.readWord();
	long q3  = fileReader.readWord();
	long q4  = fileReader.readWord();

	register.put((Object)"nip     ", (Object)(new Long(nip)));
	register.put((Object)"msr     ", (Object)(new Long(msr)));
	register.put((Object)"origgpr3", (Object)(new Long(origgpr3)));
	register.put((Object)"ctr     ", (Object)(new Long(ctr)));
	register.put((Object)"link    ", (Object)(new Long(link)));
	register.put((Object)"xer     ", (Object)(new Long(xer)));
	register.put((Object)"ccr     ", (Object)(new Long(ccr)));
	register.put((Object)"mq      ", (Object)(new Long(mq) ));
	register.put((Object)"trap    ", (Object)(new Long(trap) ));
	register.put((Object)"dar     ", (Object)(new Long(dar) ));
	register.put((Object)"dsisr   ", (Object)(new Long(dsisr) ));
	register.put((Object)"result  ", (Object)(new Long(result) ));
	register.put((Object)"q1  ", (Object)(new Long(q1) ));
	register.put((Object)"q2  ", (Object)(new Long(q2) ));
	register.put((Object)"q3  ", (Object)(new Long(q3) ));
	register.put((Object)"q4  ", (Object)(new Long(q4) ));

	DvUtils.trace("nip = " + Long.toHexString(nip), 2, false);
	DvUtils.trace("msr = " + Long.toHexString(msr), 2, false);
	DvUtils.trace("origgpr3 = " + Long.toHexString(origgpr3), 2, false);
	DvUtils.trace("ctr = " + Long.toHexString(ctr), 2, false);
	DvUtils.trace("link = " + Long.toHexString(link), 2, false);
	DvUtils.trace("xer = " + Long.toHexString(xer), 2, false);
	DvUtils.trace("ccr = " + Long.toHexString(ccr), 2, false);
	DvUtils.trace("mq = " + Long.toHexString(mq), 2, false);
	DvUtils.trace("trap = " + Long.toHexString(trap), 2, false);
	DvUtils.trace("dar = " + Long.toHexString(dar), 2, false);
	DvUtils.trace("dsisr = " + Long.toHexString(dsisr), 2, false);
	DvUtils.trace("result = " + Long.toHexString(result), 2, false);
	DvUtils.trace("q1 = " + Long.toHexString(q1), 2, false);
	DvUtils.trace("q2 = " + Long.toHexString(q2), 2, false);
	DvUtils.trace("q3 = " + Long.toHexString(q3), 2, false);
	DvUtils.trace("q4 = " + Long.toHexString(q4), 2, false);

	long fpvalid = fileReader.readWord();
	DvUtils.trace("fpvalid" + fpvalid, 2, false);
    }

}    
