/*
 * @(#)src/classes/sov/com/ibm/jvm/dump/ElfNotePsInfo.java, ras, dumpviewer 1.2    
 * ===========================================================================
 * IBM Confidential
 * OCO Source Materials
 *
 * IBM Java(tm)2 SDK, Standard Edition, v 1.3.1
 * (C) Copyright IBM Corp. 1998, 2001.
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright office.
 * ===========================================================================
 */

/*
 *
 * ===========================================================================
 *
 *
 *
 * ===========================================================================
 * Change activity:
 *
 * Reason  Date   Origin  Description
 * ------  ----   ------  ----------------------------------------------------
 * 41452  210502 nmasson  New

 *
 * ===========================================================================
 * Module Information:
 *
 * DESCRIPTION:
 * ===========================================================================
 */
package com.ibm.jvm.dump;

import java.io.*;
import java.util.*;

 /**
  * ElfNotePsInfos reads Notes sections in a Linux core file
  * The layout is derived from the kernel files
  * /usr/src/linux/include/linux/elfcore.h
  * /usr/src/linux/fs/binfmt_elf.c
  */
import java.util.*;
import java.io.*;

class ElfNotePsInfo extends ElfNote {

    ElfNotePsInfo(DvFileReader fileReader) throws IOException {
	long prepad = fileReader.readWord();
	long flags =  fileReader.readWord();
	long numThreads =  fileReader.readWord();
	long pid =  fileReader.readWord();
	long ppid = fileReader.readWord();
	long pgid =  fileReader.readWord();
	long sid  = fileReader.readWord();
	long aslwpid = fileReader.readWord();
	long agentid = fileReader.readWord();
	long sigpend = fileReader.readWord();
	long prkbase = fileReader.readLong();
	long prksize = fileReader.readWord();
	long stkbase = fileReader.readLong();
	long stksize = fileReader.readWord();
	long cpu  = fileReader.readLong();
	long cpu_ms  = fileReader.readLong();
	long sys = fileReader.readLong();
	long sys_ms = fileReader.readLong();
	long ccpu = fileReader.readLong();
	long ccpu_ms = fileReader.readLong();
	long csys = fileReader.readLong();
	long csys_ms = fileReader.readLong();
	long sigtrace = fileReader.readWord();
	long fault = fileReader.readWord();
	long[] sysentry = new long[16];
	for (int i=0; i<16; i++) {
	    sysentry[i] = fileReader.readWord();
	}
	long[] sysexit = new long[16];
	for (int i=0; i<16; i++) {
	    sysexit[i] = fileReader.readWord();
	}
	long dmodel = fileReader.readByte();
	byte[] pad = new byte[3];
	fileReader.read(pad);
	byte[] filler = new byte[19];
	fileReader.read(filler);
	long lwp =  fileReader.readWord();

	DvUtils.trace("flags = " + Long.toHexString(flags), 2, false);
	DvUtils.trace("numThreads = " + Long.toHexString(numThreads), 2, false);
	DvUtils.trace("pid = " + Long.toHexString(pid), 2, false);
	DvUtils.trace("ppid = " + Long.toHexString(ppid), 2, false);
	DvUtils.trace("pgid = " + Long.toHexString(pgid), 2, false);
	DvUtils.trace("sid = " + Long.toHexString(sid), 2, false);
	DvUtils.trace("aslwpid = " + Long.toHexString(aslwpid), 2, false);
	DvUtils.trace("agentid = " + Long.toHexString(agentid), 2, false);
	DvUtils.trace("sigpend = " + Long.toHexString(sigpend), 2, false);
	DvUtils.trace("prkbase = " + Long.toHexString(prkbase), 2, false);
	DvUtils.trace("prksize = " + Long.toHexString(prksize), 2, false);
	DvUtils.trace("stkbase = " + Long.toHexString(stkbase), 2, false);
	DvUtils.trace("stksize = " + Long.toHexString(stksize), 2, false);
	DvUtils.trace("cpu = " + Long.toHexString(cpu), 2, false);
	DvUtils.trace("cpu_ms = " + Long.toHexString(cpu_ms), 2, false);
	DvUtils.trace("sys = " + Long.toHexString(sys), 2, false);
	DvUtils.trace("sys_ms = " + Long.toHexString(sys_ms), 2, false);
	DvUtils.trace("ccpu = " + Long.toHexString(ccpu), 2, false);
	DvUtils.trace("ccpu_ms = " + Long.toHexString(ccpu_ms), 2, false);
	DvUtils.trace("csys = " + Long.toHexString(csys), 2, false);
	DvUtils.trace("csys_ms = " + Long.toHexString(csys_ms), 2, false);
	DvUtils.trace("sigtrace = " + Long.toHexString(sigtrace), 2, false);
	DvUtils.trace("fault = " + Long.toHexString(fault), 2, false);
	//DvUtils.trace("sysentry = " + Long.toHexString(sysentry), 2, false);
	//DvUtils.trace("sysexit = " + Long.toHexString(sysexit), 2, false);
	DvUtils.trace("dmodel = " + Long.toHexString(dmodel), 2, false);
	DvUtils.trace("lwp = " + Long.toHexString(lwp), 2, false);

	throw new IOException("End");
    }
}
