/*
 * @(#)src/classes/sov/com/ibm/jvm/dump/ExAddressSpace.java, ras, dumpviewer 1.1    
 * ===========================================================================
 * IBM Confidential
 * OCO Source Materials
 *
 * IBM Java(tm)2 SDK, Standard Edition, v 1.3.1
 * (C) Copyright IBM Corp. 1998, 2001.
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright office.
 * ===========================================================================
 */

/*
 *
 * ===========================================================================
 *
 *
 *
 * ===========================================================================
 * Change activity:
 *
 * Reason  Date   Origin  Description
 * ------  ----   ------  ----------------------------------------------------
 *
 * ===========================================================================
 * Module Information:
 *
 * DESCRIPTION:
 * ===========================================================================
 */

package com.ibm.jvm.dump;

import java.io.*;
import java.util.*;

public class ExAddressSpace {

    ExProcess process;

    ExAddressSpace(ExEnvData environment, ExLoaded loaded, ExThread[] thread) {
        //super(data);
        process = new ExProcess(environment, loaded, thread);
	DvUtils.trace("ExAddress created", 2, false);
    }

    ExAddressSpace(ExProcess process) {
	this.process = process;
    }

    /**
     * Serialise to SDFF file
     */
    void printSdff(Sdff sdff, MemoryMap map) throws IOException {
        long start = sdff.getFilePointer();
        sdff.writeLong(0l);
        sdff.writeBytes("ADDRSPC ");
        sdff.writeLong(0);				// id
        sdff.writeLong(1);				// process count
	// fix by Philr -- process index is an int! not a short!
      	sdff.writeInt(0);				// process index
	for(int i=0; i<15; i++) {
	    sdff.writeBytes("PAD ");
	}
        process.printSdff(sdff, map);
        sdff.writeLong(-1l);
        sdff.printLength(start);
    }

}

