/*
 * @(#)src/classes/sov/com/ibm/jvm/dump/ExEnvData.java, ras, dumpviewer 1.2    
 * ===========================================================================
 * IBM Confidential
 * OCO Source Materials
 *
 * IBM Java(tm)2 SDK, Standard Edition, v 1.3.1
 * (C) Copyright IBM Corp. 1998, 2001.
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright office.
 * ===========================================================================
 */

/*
 *
 * ===========================================================================
 *
 *
 *
 * ===========================================================================
 * Change activity:
 *
 * Reason  Date   Origin  Description
 * ------  ----   ------  ----------------------------------------------------
 * 41452  210502 nmasson  New

 *
 * ===========================================================================
 * Module Information:
 *
 * DESCRIPTION:
 * ===========================================================================
 */
package com.ibm.jvm.dump;

import java.io.*;
import java.util.*;

class ExEnvData {
    Vector env = new Vector();
    byte[] javaVersion = new byte[32];

    ExEnvData(DvFileReader reader, long envPtr) throws IOException {
	// Read the environment data from the char**
	long listPtr = envPtr;
	long nextListPtr;
	long address;
	String pair;

	DvUtils.trace("EnvPtr="+Long.toHexString(envPtr), 2, false);
	reader.setAddress(envPtr);
	listPtr = reader.readAddress();
	DvUtils.trace("Env=" + Long.toHexString(listPtr), 2, false);
	nextListPtr = reader.getPos();

	reader.setAddress(listPtr);
	String name, value;
	while(listPtr != 0) {
	    reader.setAddress(listPtr);
	    pair = reader.readString();
	    DvUtils.trace("Env:" + pair, 2, false);
	    env.add(pair);
	    reader.setPos(nextListPtr);
	    listPtr = reader.readAddress();
	    DvUtils.trace("Env=" + Long.toHexString(listPtr), 2, false);
	    nextListPtr = reader.getPos();
	}
    }
    void printSdff(Sdff sdff) throws IOException {
	DvUtils.trace("Printing Environment", 2, false);
	long start = sdff.getFilePointer();
	sdff.writeLong(0);
	sdff.writeBytes(new String("ENVDATA "));
	sdff.write(javaVersion);
	sdff.writeLong(0);	// Size of javaHome
				// JavaHome
	sdff.writeLong(0);	// Size of JavaDll
				// JavaDll
	long envStart = sdff.getFilePointer();
	sdff.writeLong(0);	// Size of environment section
	
	Enumeration list = env.elements();
	String value;
	while(list.hasMoreElements()) {
	    value = (String)list.nextElement();
	    sdff.writeBytes(value);
	    sdff.writeByte(0);
	}
	sdff.printLength(envStart);
	sdff.writeLong(0);	// Size of ClassPath
				// ClassPath
	sdff.printLength(start);
    }

}
