/*
 * @(#)src/classes/sov/com/ibm/jvm/dump/ExLoaded.java, ras, dumpviewer 1.4
 * ===========================================================================
 * IBM Confidential
 * OCO Source Materials
 *
 * IBM Java(tm)2 SDK, Standard Edition, v 1.3.1
 * (C) Copyright IBM Corp. 1998, 2001.
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright office.
 * ===========================================================================
 */

/*
 *
 * ===========================================================================
 *
 *
 *
 * ===========================================================================
 * Change activity:
 *
 * Reason  Date   Origin  Description
 * ------  ----   ------  ----------------------------------------------------
 * 41452  210502 nmasson  New

 *
 * ===========================================================================
 * Module Information:
 *
 * DESCRIPTION:
 * ===========================================================================
 */
package com.ibm.jvm.dump;

import java.io.*;

 /**
  */
import java.util.*;
import java.io.*;

class ExLoaded {
    Vector segment = new Vector();

    ExLoaded(DvFileReader reader, long loadedPtr) throws IOException {
        // Read the loaded data
	
        DvUtils.trace("LoadedePtr="+Long.toHexString(loadedPtr), 2, false);
        reader.setPos(loadedPtr);
        long address;
	while((address = reader.readAddress()) != 0) {
	    long size = reader.readAddress();
	    long namePtr = reader.readAddress();
	    long nextSection = reader.getPos();
	    reader.setAddress(namePtr);
	    String name = reader.readString();
	    reader.setPos(nextSection);
	    DvUtils.trace("Address " + Long.toHexString(address) + 
		" Size " + Long.toHexString(size) + name, 2, false);
	    Segment s = new Segment(name, address, size, 
		DvModule.MODULE_IS_TEXT);
	    segment.add(s);
	}
    }
    void printSdff(Sdff sdff) throws IOException {
        DvUtils.trace("Printing Loaded", 2, false);
	sdff.align(4);
        long start = sdff.getFilePointer();
        sdff.writeLong(0);
        sdff.writeBytes(new String("LOADED  "));
       	Enumeration list = segment.elements();
	Segment mySegment;
        while(list.hasMoreElements()) {
            mySegment = (Segment)list.nextElement();
            sdff.writeLong(mySegment.moduleAddress.getAddressAsLong()); 
            sdff.writeLong(mySegment.moduleSize); 
            sdff.writeLong(mySegment.moduleName.length()); 
	    sdff.writeBytes(mySegment.moduleName);
        }
        sdff.printLength(start);
	// Write Metadata
	sdff.writeLong(-1);
    }
}    
