/*
 * @(#)src/classes/sov/com/ibm/jvm/dump/ExProcess.java, ras, dumpviewer 1.6    
 * ===========================================================================
 * IBM Confidential
 * OCO Source Materials
 *
 * IBM Java(tm)2 SDK, Standard Edition, v 1.3.1
 * (C) Copyright IBM Corp. 1998, 2001.
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright office.
 * ===========================================================================
 */

/*
 *
 * ===========================================================================
 *
 *
 *
 * ===========================================================================
 * Change activity:
 *
 * Reason  Date   Origin  Description
 * ------  ----   ------  ----------------------------------------------------
 * 41452  210502 nmasson  New

 *
 * ===========================================================================
 * Module Information:
 *
 * DESCRIPTION:
 * ===========================================================================
 */
package com.ibm.jvm.dump;


 /**
  *
  */
import java.util.*;
import java.io.*;

class ExProcess {
static final String[] sigName =    {
"        ",
"SIGHUP  ",   /*   1	 Hangup (POSIX).  */
"SIGINT  ",   /*   2	 Interrupt (ANSI).  */
"SIGQUIT ",   /*   3	 Quit (POSIX).  */
"SIGILL  ",   /*   4	 Illegal instruction (ANSI).  */
"SIGTRAP ",   /*   5	 Trace trap (POSIX).  */
"SIGABRT ",   /*   6	 Abort (ANSI).  */
"SIGBUS  ",   /*   7	 BUS error (4.2 BSD).  */
"SIGFPE  ",   /*   8	 Floating-point exception (ANSI).  */
"SIGKILL ",   /*   9	 Kill, unblockable (POSIX).  */
"SIGUSR1 ",   /*  10	 User-defined signal 1 (POSIX).  */
"SIGSEGV ",   /*  11	 Segmentation violation (ANSI).  */
"SIGUSR2 ",   /*  12	 User-defined signal 2 (POSIX).  */
"SIGPIPE ",   /*  13	 Broken pipe (POSIX).  */
"SIGALRM ",   /*  14	 Alarm clock (POSIX).  */
"SIGTERM ",   /*  15	 Termination (ANSI).  */
"SIGSTKFL",   /*  16 SIGSTKFLT	 Stack fault.  */
"SIGCHLD ",   /*  17	 Child status has changed (POSIX).  */
"SIGCONT ",   /*  18	 Continue (POSIX).  */
"SIGSTOP ",   /*  19	 Stop, unblockable (POSIX).  */
"SIGTSTP ",   /*  20	 Keyboard stop (POSIX).  */
"SIGTTIN ",   /*  21	 Background read from tty (POSIX).  */
"SIGTTOU ",   /*  22	 Background write to tty (POSIX).  */
"SIGURG  ",   /*  23	 Urgent condition on socket (4.2 BSD).  */
"SIGXCPU ",   /*  24	 CPU limit exceeded (4.2 BSD).  */
"SIGXFSZ ",   /*  25	 File size limit exceeded (4.2 BSD).  */
"SIGVTALR",   /*  26 SIGVTALRM	 Virtual alarm clock (4.2 BSD).  */
"SIGPROF ",   /*  27	 Profiling alarm clock (4.2 BSD).  */
"SIGWINCH",   /*  28	 Window size change (4.3 BSD, Sun).  */
"SIGIO   ",   /*  29	 I/O now possible (4.2 BSD).  */
"SIGPWR  ",   /*  30	 Power failure restart (System V).  */
"SIGSYS  "    /*  31	 Bad system call.  */
};
    SDFFJStackTr javaStack;
    Vector javaThread;
    Vector module;
    HPIModule hpiData;
    XHPIModule xhpiData;
    DvModule hpiText;
    long signalNumber = 0;
    long pid = 0;
    byte[] commandLine;
    ExEnvData environment;
    ExLoaded loaded;

    ExProcess(ElfNote note) {
	javaThread = new Vector();
	module = new Vector();
	commandLine = new byte[256];
	pid = note.pid.longValue();
	signalNumber = note.signal;
    }

    ExProcess(ExEnvData env, ExLoaded loaded, ExThread[] thread) {
    }

    boolean populate(HashMap noteList) throws IOException {
	return hpiData.populateThread(this, noteList);
    }
    void printSdff(Sdff sdff, MemoryMap map) throws IOException {
	DvUtils.trace("Printing Process", 2, false);
	long start = sdff.getFilePointer();
        sdff.writeLong(0l);
        sdff.writeBytes("PROCESS ");
	sdff.writeLong(pid);				//process Id
	sdff.writeLong(javaThread.size());		//thread Count
        sdff.writeLong(-1l);				//current Thread
        sdff.writeLong(signalNumber);
	DvUtils.trace("Signal " + signalNumber, 2, false);
        sdff.writeBytes(sigName[(int)signalNumber]);
	long threadOffset = sdff.getFilePointer();
	environment.printSdff(sdff);
	//IBM.FIXME we have two different segment lists
	//map.printLoaded(sdff);
	loaded.printSdff(sdff);
        sdff.printLength(threadOffset);
	Enumeration list = javaThread.elements();
	while(list.hasMoreElements()) {
	    ExThread jvmThread = (ExThread)list.nextElement();
	    jvmThread.printSdff(sdff);
	}
        sdff.writeLong(-1l);
        sdff.printLength(start);

    }
}    
