/*
 * @(#)src/classes/sov/com/ibm/jvm/dump/ExProcessAddressSpace.java, ras, dumpviewer 1.2    
 * ===========================================================================
 * IBM Confidential
 * OCO Source Materials
 *
 * IBM Java(tm)2 SDK, Standard Edition, v 1.3.1
 * (C) Copyright IBM Corp. 1998, 2001.
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright office.
 * ===========================================================================
 */

/*
 *
 * ===========================================================================
 *
 *
 *
 * ===========================================================================
 * Change activity:
 *
 * Reason  Date   Origin  Description
 * ------  ----   ------  ----------------------------------------------------
 * 41452  210502 nmasson  New

 *
 * ===========================================================================
 * Module Information:
 *
 * DESCRIPTION:
 * ===========================================================================
 */
package com.ibm.jvm.dump;


 /**
  * 
  */

import java.util.*;
import java.io.*;

class ExProcessAddressSpace {
    Vector addressSpace;

    ExProcessAddressSpace(ExProcess process) {
	addressSpace = new Vector();
	ExAddressSpace space = new ExAddressSpace(process);
	addressSpace.add(space);
    }

    void printSdff(Sdff sdff, MemoryMap map) throws IOException {
	DvUtils.trace("Printing ProcessAddressSpace", 0, false);
	long start = sdff.getFilePointer();
        SdffStd Std = new SdffStd(SdffConstants.SEGMENT_Sdffprth,
	    SdffConstants.VERSION1_0_0);
        Std.printSdff(sdff);
	// Write the number of address spaces
	sdff.writeLong(addressSpace.size());
        Enumeration list = addressSpace.elements();
        while(list.hasMoreElements()) {
            ExAddressSpace space = (ExAddressSpace)list.nextElement();
            space.printSdff(sdff, map);
        }
	// Add padding
	for(int i=0; i<8; i++) {
	    sdff.writeBytes("PAD ");
	}
	// Write Metadata
        sdff.writeLong(-1l);
        sdff.printLength(start);
    }
}
