/*
 * @(#)src/classes/sov/com/ibm/jvm/dump/ExThread.java, ras, dumpviewer 1.4    
 * ===========================================================================
 * IBM Confidential
 * OCO Source Materials
 *
 * IBM Java(tm)2 SDK, Standard Edition, v 1.3.1
 * (C) Copyright IBM Corp. 1998, 2001.
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright office.
 * ===========================================================================
 */

/*
 *
 * ===========================================================================
 *
 *
 *
 * ===========================================================================
 * Change activity:
 *
 * Reason  Date   Origin  Description
 * ------  ----   ------  ----------------------------------------------------
 *
 * ===========================================================================
 * Module Information:
 *
 * DESCRIPTION:
 * ===========================================================================
 */
package com.ibm.jvm.dump;

import java.util.*;
import java.io.*;



 /**
  *  Description: Encapsulation of the thread information contained in an
  *               SDFF format dump
  *
  *
  *
  *
  *
  */
class ExThread {

Long   pid; 
long   tid; // thread id as a java long
long   stackptr;
long   execEnv; // address in memory of ExecEnv
long   pc;      // program counter
ExRegister register;

    ExThread(long pid, long tid, long execEnv, HashMap noteList) {
        this.pid = new Long(pid);
        this.tid = tid;
        this.execEnv = execEnv;
	if (noteList.containsKey(this.pid)) {
	    DvUtils.trace("Matched registers for " + this.pid, 1, false);
	    ElfNote pData = (ElfNote)noteList.get(this.pid);
	    register = new ExRegister(pData.register);
	} else {
	    DvUtils.trace("No registers for " + this.pid, 1, false);
	    register = new ExRegister();
	}
    }

    /**
     * Serialises to SDFF file
     */
    void printSdff(Sdff sdff) throws IOException {
	DvUtils.trace("Printing Thread", 0, false);
	sdff.align(8);
    	long start = sdff.getFilePointer();
        sdff.writeLong(0l);
        sdff.writeBytes("THREAD  ");
        sdff.writeLong(tid);
        sdff.writeInt(-1); //IBM.FIXME
        sdff.writeInt(-1); //IBM.FIXME
        sdff.writeLong(0);	//(stackptr);
        sdff.writeLong(0);	//(pc);
        sdff.writeLong(execEnv);
        sdff.writeInt(-1); //IBM.FIXME
        sdff.writeInt(-1); //IBM.FIXME
        //stackTrace.printSdff(sdff);
        register.printSdff(sdff);
        // Add padding
        for(int i=0; i<8; i++) {
            sdff.writeBytes("PAD ");
        }
	// Print Metadata
        sdff.writeLong(-1l);
        sdff.printLength(start);
    }
}
