/*
 * @(#)src/classes/sov/com/ibm/jvm/dump/Extract.java, ras, dumpviewer 1.4    
 * ===========================================================================
 * IBM Confidential
 * OCO Source Materials
 *
 * IBM Java(tm)2 SDK, Standard Edition, v 1.3.1
 * (C) Copyright IBM Corp. 1998, 2001.
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright office.
 * ===========================================================================
 */

/*
 *
 * ===========================================================================
 *
 *
 *
 * ===========================================================================
 * Change activity:
 *
 * Reason  Date   Origin  Description
 * ------  ----   ------  ----------------------------------------------------
 * 41452  210502 nmasson  New

 *
 * ===========================================================================
 * Module Information:
 *
 * DESCRIPTION:
 * ===========================================================================
 */
package com.ibm.jvm.dump;


 /**
  *
  */

import java.io.*;
import java.util.*;

class Extract {
    public static void main(String[] Args) throws IOException {
	DvFileReader reader;
	Layout layout;
	String outputFile;
	RandomAccessFile core = new RandomAccessFile(Args[0], "r");
	layout = Layout.getLayout(core);
    	reader = layout.getFileReader(core);

	SDFFDump header = layout.readHeader((DvFileReader)reader);
	((ElfHeader)header).dump();
	LinuxMemoryMap map = (LinuxMemoryMap)layout.readSegments(
	    (DvFileReader)reader, header);
	reader.setMapper(map);
	ElfNotes notes = new ElfNotes((DvFileReader)reader, (ElfHeader)header);
	HashMap register = notes.register;

	ExProcess process = new ExProcess(notes.note);
	//IBM.FIXME use proper command line parsing
	DvUtils.setVerbose(true);
	outputFile = Args[1];
	LinuxJVMLayout jvm = new LinuxJVMLayout(process, map, 
	    (DvFileReader)reader);

	DvUtils.trace("HPIData = " + process.hpiData, 2, false); 
	if(process.hpiData != null) {
	    LinuxHPIModule hpiModule = (LinuxHPIModule)process.hpiData;
	    hpiModule.populate();
   	}
	LinuxXHPIModule xhpi = new LinuxXHPIModule(reader, process);
	process.populate(register);
	ExProcessAddressSpace p = new ExProcessAddressSpace(process);

	Sdff sdff = new Sdff(outputFile);
	header.printSdff(sdff);

 	p.printSdff(sdff, map);
	map.printSdff(sdff);
	map.printMemory(sdff, reader);
    }
}
