/*
 * @(#)src/classes/sov/com/ibm/jvm/dump/Layout.java, ras, dumpviewer 1.2
 * ===========================================================================
 * IBM Confidential
 * OCO Source Materials
 *
 * IBM Java(tm)2 SDK, Standard Edition, v 1.3.1
 * (C) Copyright IBM Corp. 1998, 2001.
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright office.
 * ===========================================================================
 */

/*
 *
 * ===========================================================================
 *
 *
 *
 * ===========================================================================
 * Change activity:
 *
 * Reason  Date   Origin  Description
 * ------  ----   ------  ----------------------------------------------------
 * 41452  210502 nmasson  New

 *
 * ===========================================================================
 * Module Information:
 *
 * DESCRIPTION:
 * ===========================================================================
 */
package com.ibm.jvm.dump;


 /**
  * Layout is an abstract class representing the data organisation of
  * a file
  */

import java.io.*;

abstract class Layout {
    static Layout getLayout(RandomAccessFile file) throws IOException {
	Layout layout;
        byte[] Ident = new byte[4];
        file.read(Ident, 0, 4);
	String IdentString = new String(Ident);
	if(IdentString.equals("\177ELF")) {
            DvUtils.trace("ELF format", 0, false);
	    layout = new Elf();
	} else {
	    //layout = new Aix();
	    layout = null;
	}
	return(layout);
    }
    abstract DvFileReader getFileReader(RandomAccessFile file) 
	throws IOException;
    abstract SDFFDump readHeader(DvReader reader) 
	throws IOException;
    abstract MemoryMap readSegments(DvFileReader reader, SDFFDump header) 
	throws IOException;
}
