/*
 * @(#)src/classes/sov/com/ibm/jvm/dump/LinuxJVMLayout.java, ras, dumpviewer 1.4
 * ===========================================================================
 * IBM Confidential
 * OCO Source Materials
 *
 * IBM Java(tm)2 SDK, Standard Edition, v 1.3.1
 * (C) Copyright IBM Corp. 1998, 2001.
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright office.
 * ===========================================================================
 */

/*
 *
 * ===========================================================================
 *
 *
 *
 * ===========================================================================
 * Change activity:
 *
 * Reason  Date   Origin  Description
 * ------  ----   ------  ----------------------------------------------------
 * 41452  210502 nmasson  New

 *
 * ===========================================================================
 * Module Information:
 *
 * DESCRIPTION:
 * ===========================================================================
 */
package com.ibm.jvm.dump;


 /**
  *
  */

import java.io.*;
import java.util.*;

class LinuxJVMLayout {

    LinuxJVMLayout(ExProcess process, LinuxMemoryMap map, DvFileReader reader) 
	throws IOException {

	DvUtils.trace("LinuxJVMLayout", 0, false);
    	Enumeration elements = map.segments.elements();
	//IBM.FIXME There must be a neater way to do this
	String sovPattern, hpiPattern;
    	if(reader.endType instanceof BigEnd) {
	    DvUtils.trace("Look for big-end patterns", 2, false);
	    sovPattern = "HPIRAS \0\252\125\252\125";
	    sovPattern = "HPIRAS\0\0\252\125\252\125"; //IBM.FIXME
	    hpiPattern = "HPIPRAS\0\252\125\252\125";
    	} else {
	    DvUtils.trace("Look for little-end patterns", 2, false);
	    sovPattern = "HPIRAS \0\125\252\125\252";
	    sovPattern = "HPIRAS\0\0\125\252\125\252"; //IBM.FIXME
	    hpiPattern = "HPIPRAS\0\125\252\125\252";
    	}
    	searchCore: while(elements.hasMoreElements()) {
	    Segment seg = (Segment)elements.nextElement();
		    DvUtils.trace("Segment type=" + seg.moduleType +
			" length=" + seg.moduleSize + " offset=" +
			Long.toHexString(seg.offset), 2, false);
	    if(seg.moduleType == DvModule.MODULE_IS_DATA) {
		if(seg.moduleSize <= 0x2000000) {
		    DvUtils.trace("Segment type=" + seg.moduleType +
			" length=" + seg.moduleSize + " offset=" +
			Long.toHexString(seg.offset), 2, false);
		    int bufSize = 2048;
		    int size = (int)seg.moduleSize;
		    byte[] buffer = new byte[bufSize];
		    reader.setPos(seg.offset);
		    while(size > 0) {
		    	reader.read(buffer);
			size -= bufSize;
		    	String s = new String(buffer);
		    	int data = s.indexOf(sovPattern);
		    	if (data != -1) {
		    	    DvUtils.trace("HPI Found", 2, false);
			    process.hpiData = new LinuxHPIModule(seg);
			    break searchCore;
			}
		    }
		}
	    }
	}
    }
}
