/*
 * @(#)src/classes/sov/com/ibm/jvm/dump/LinuxMemoryMap.java, ras, dumpviewer 1.3
 * ===========================================================================
 * IBM Confidential
 * OCO Source Materials
 *
 * IBM Java(tm)2 SDK, Standard Edition, v 1.3.1
 * (C) Copyright IBM Corp. 1998, 2001.
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright office.
 * ===========================================================================
 */

/*
 *
 * ===========================================================================
 *
 *
 *
 * ===========================================================================
 * Change activity:
 *
 * Reason  Date   Origin  Description
 * ------  ----   ------  ----------------------------------------------------
 * 41452  210502 nmasson  New

 *
 * ===========================================================================
 * Module Information:
 *
 * DESCRIPTION:
 * ===========================================================================
 */
package com.ibm.jvm.dump;


 /**
  *
  */

import java.io.*;
import java.util.*;

class LinuxMemoryMap extends MemoryMap implements Mapper {
    SDFFProcess process;

    LinuxMemoryMap(DvFileReader reader, ElfHeader header) throws IOException {
    long length;
    long offset;
    long address;
    long type;
    long flags;
    long alignment;
    long physicalAddress;
    long fileSize;

    this.process = process;

    DvUtils.trace("creating LinuxMemoryMap", 2, false);
    reader.setPos(header.programHeaderOffset);
    for(int index = 0; index < header.numProgramHeaders; index++) {
	reader.setPos(header.programHeaderOffset + 
	    (index * header.programHeaderEntrySize));
	if(reader.wordLength.size == 8) {
    	    type = reader.readWord();
	    flags = reader.readWord();
	    offset = reader.readAddress();
	    address = reader.readAddress();
	    physicalAddress = reader.readAddress();
	    fileSize = reader.readLong();
	    length = reader.readLong();
	    alignment = reader.readLong();
	} else {
	    // 32 bit
            type = reader.readWord();
            offset = reader.readAddress();
            address = reader.readAddress();
            physicalAddress = reader.readAddress();
            fileSize = reader.readWord();
            length = reader.readWord();
            flags = reader.readWord();
            alignment = reader.readWord();
	}

    	//HACK determine which is data and which is text
	int moduleType;
	Segment seg;
    	if(fileSize > 0) {
	    moduleType = DvModule.MODULE_IS_DATA;
	    seg = new Segment("", address, length, 
	    	moduleType, reader, offset);
	    DvUtils.trace("Data Segment", 2, false);
	} else {
	    moduleType = DvModule.MODULE_IS_TEXT;
	    seg = new Segment("", address, length, moduleType);
	    DvUtils.trace("Text Segment", 2, false);
	}
	//Segment seg = new Segment("", address, length, 
	//    moduleType, reader, offset);
	segments.add(seg);

	DvUtils.trace("Entry " + index + " " + 
	    Long.toHexString(length) + " " 
	    + Long.toHexString(offset) + " " + 
	    Long.toHexString(address) + 
	    " " + Long.toHexString(length), 2, false); 
    }
    }

    public long getOffset(long address) {
	DvUtils.trace("getOffset(" + Long.toHexString(address) + ")", 2, false);
        for(int index = 0; index < segments.size(); index++) {
	    Segment seg = (Segment)segments.get(index);
            if((address >= seg.moduleAddress.getAddressAsLong()) && 
		(address <= seg.moduleAddress.getAddressAsLong() +
                    seg.moduleSize)) {
		DvUtils.trace("Segment start=" + 
		    Long.toHexString(seg.moduleAddress.getAddressAsLong()) +
        	    " offset=" + Long.toHexString(seg.offset) + " return=" +
		     Long.toHexString (seg.offset + address - 
			seg.moduleAddress.getAddressAsLong()), 2, false);
                return(seg.offset + address - 
			seg.moduleAddress.getAddressAsLong());
            }
        }
        return 0;
    }
}
