/*
 * @(#)src/classes/sov/com/ibm/jvm/dump/LittleEnd.java, ras, dumpviewer 1.1
 * ===========================================================================
 * IBM Confidential
 * OCO Source Materials
 *
 * IBM Java(tm)2 SDK, Standard Edition, v 1.3.1
 * (C) Copyright IBM Corp. 1998, 2001.
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright office.
 * ===========================================================================
 */

/*
 *
 * ===========================================================================
 *
 *
 *
 * ===========================================================================
 * Change activity:
 *
 * Reason  Date   Origin  Description
 * ------  ----   ------  ----------------------------------------------------
 * 41452  210502 nmasson  New

 *
 * ===========================================================================
 * Module Information:
 *
 * DESCRIPTION:
 * ===========================================================================
 */
package com.ibm.jvm.dump;


 /**
  * LittleEnd encapsulates how to translates bytes on a little-endian
  * machine into a Java data type
  */

class LittleEnd implements WordType {
   /**
    * Converts a byte array pattern in little-end format to a Java type
    */
   public long toLong(byte[] pattern) {
	long retval = 0;
	for(int off = pattern.length-1; off >= 0; off--) {
            retval <<= 8;
            retval += ((long)(pattern[off])&0xFF);
        }
        return(retval);
    }
}
