/*
 * @(#)src/classes/sov/com/ibm/jvm/dump/MemoryMap.java, ras, dumpviewer 1.5    
 * ===========================================================================
 * IBM Confidential
 * OCO Source Materials
 *
 * IBM Java(tm)2 SDK, Standard Edition, v 1.3.1
 * (C) Copyright IBM Corp. 1998, 2001.
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright office.
 * ===========================================================================
 */

/*
 *
 * ===========================================================================
 *
 *
 *
 * ===========================================================================
 * Change activity:
 *
 * Reason  Date   Origin  Description
 * ------  ----   ------  ----------------------------------------------------
 * 41452  210502 nmasson  New
 *
 * ===========================================================================
 * Module Information:
 *
 * DESCRIPTION:
 * ===========================================================================
 */
package com.ibm.jvm.dump;


 /**
  * Encapsulates a memory map
  */

import java.io.*;
import java.util.*;

class MemoryMap {
    Vector segments = new Vector(50);

    MemoryMap() {}
    MemoryMap(DvFileReader reader, SDFFDump header) throws IOException {}

    void printSdff(Sdff sdff) throws IOException {
	// First print the map
	long start = sdff.getFilePointer();
        SdffStd Std = new SdffStd(SdffConstants.SEGMENT_Sdffmmap,
	    SdffConstants.VERSION1_0_0);
        Std.printSdff(sdff);
	Enumeration list = segments.elements();
	while(list.hasMoreElements()) {
	    Segment seg = (Segment)list.nextElement();
	    seg.printSdff(sdff);
	}
	// Write metadata
	sdff.writeLong(-1l);
	sdff.printLength(start);
    }

    void printMemory(Sdff sdff, DvFileReader reader) throws IOException {
	// First fix up the file pointers in the map
	long start = sdff.getFilePointer();

        SdffStd Std = new SdffStd(SdffConstants.SEGMENT_Sdffmem,
	    SdffConstants.VERSION1_0_0);
        Std.printSdff(sdff);
	sdff.fixupMap();
	reader.setPos(0);
	int bufferSize = 32768;
	long fileSize = reader.core.length();
	byte[] buffer = new byte[bufferSize];
	while(fileSize > 0) {
	    if (fileSize < bufferSize) {
		buffer = new byte[(int)fileSize];
	    }
	    fileSize -= buffer.length;
	    reader.read(buffer);
	    sdff.write(buffer);
	}
	
	// Write metadata
	sdff.writeLong(-1l);
	sdff.printLength(start);
    }
    void printLoaded(Sdff sdff) throws IOException {
        DvUtils.trace("Printing Loaded", 0, false);
	// Align to a four-byte boundary
	sdff.align(4);

        long start = sdff.getFilePointer();
        sdff.writeLong(0l);
        sdff.writeBytes("LOADED  ");
        Enumeration list = segments.elements();
        while(list.hasMoreElements()) {
            Segment segment = (Segment)list.nextElement();
            if(segment.moduleType == DvModule.MODULE_IS_TEXT) {
                ((Segment)segment).printSdffLoaded(sdff);
            }
        }
        sdff.writeLong(-1l);
        sdff.printLength(start);
    }

}
