/*
 * @(#)src/classes/sov/com/ibm/jvm/dump/SDFFAddress.java, ras, dumpviewer 1.10
 * ===========================================================================
 * IBM Confidential
 * OCO Source Materials
 *
 * IBM Java(tm)2 SDK, Standard Edition, v 1.3.1
 * (C) Copyright IBM Corp. 1998, 2001.
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright office.
 * ===========================================================================
 */

/*
 *
 * ===========================================================================
 *
 *
 *
 * ===========================================================================
 * Change activity:
 *
 * Reason  Date   Origin  Description
 * ------  ----   ------  ----------------------------------------------------
 * 36524  020502 PHILR:  New for feature 36524
 * 36524  240602 nmasson Fix constructor
 *
 * ===========================================================================
 * Module Information:
 *
 * DESCRIPTION:
 * ===========================================================================
 */

package com.ibm.jvm.dump;


 /**
  *  Description: Whats the purpose of this class
  *
  *
  *
  *
  *
  */
public class SDFFAddress extends DvAddress {


 /**
  *   <p>Description:
  *   </p>
  *   <p>Input      :
  *   </p>
  *   <p>Returned   :
  *   </p>
  */
 public SDFFAddress () {

 }

 /**
  *   <p>Description:
  *   </p>
  *   <p>Input      :
  *   </p>
  *   <p>Returned   :
  *   </p>
  */
 public SDFFAddress (long addr) {

    address = addr;

 }

 /**
  *   <p>Description:
  *   </p>
  *   <p>Input      :
  *   </p>
  *   <p>Returned   :
  *   </p>
  */
 public SDFFAddress (String stAddr) {
   try {
     //address =
   }
   catch (Exception e) {
   }

 }



 /**
  *   <p>Description:
  *   </p>
  *   <p>Input      :
  *   </p>
  *   <p>Returned   :
  *   </p>
  */
 public void setAddress(long a) {
  address = a;
 }

 /**
  *   <p>Description:
  *   </p>
  *   <p>Input      :
  *   </p>
  *   <p>Returned   :
  *   </p>
  */
 public String convertToHex() {
  return Long.toHexString(address);
 }

 /**
  *   <p>Description:
  *   </p>
  *   <p>Input      :
  *   </p>
  *   <p>Returned   :
  *   </p>
  */
 public long   getAddressAsLong() {return address;}

 /**
  *   <p>Description: Converts the current DvAddress into one that
  *                   addresses somewhere different either above or below
  *                   this address. If the address to be formed would be
  *                   above 64 bit range then throws DvAddressException
  *                   and DvAddress object is unaltered.
  *   </p>
  *   <p>Input      :
  *   </p>
  *   <p>Returned   :
  *   </p>
  */
 public void offsetBy(long offset) throws DvAddressException {


   if (address >= 0) {
    // Its currently a +ve address (max 7FFFFFFF FFFFFFFF)
    // if offset is -ve then provided it doesn't take us below 0
    // we are ok, else throw DvAddressException
    if (offset <=0 ) {
       if (address+offset < 0) {
         //System.out.println("Point xxx1:" + address + ":" + offset);
         DvAddressException ex =
           new DvAddressException("New DvAddress would be below 0");

         throw ex;
       }
       else {
            //System.out.println("Point xxx2:" + address + ":" + offset);
            address = address + offset;
       }
    }
    else
    {
       // offset is +ve so we need to do something to check that
       // we are not going to go above top of memory (8allzeros)
       // So take address away from maxlong and see whether enough
       // is left to add offfset without going above maxlong
       if ((Long.MAX_VALUE - address) < offset) {
         // we are ok
         //System.out.println("Point xxx3:" + address + ":" + offset);
         address = address+offset;
       }
       else
       {
         // need to do some shenaningans as we go into
         // -ve numbers
         //System.out.println("Point xxx4:" + address + ":" + offset);
         long newaddress = Long.MAX_VALUE-address;  // gets us amount left
                                                    // until MAX
         offset = offset-newaddress;                 // offset reduced by above
         address = Long.MIN_VALUE+offset-1;         // address now recalced
                                                    // from 8allzeros

       } // end of else
    }
   }
   else
   {
    // its a -ve address (80000000 000000000 upwards) which is a high address so
    // if offset is -ve we are always going to be ok, but we do need to do some
    // figring to see if are going to go from -ve to +ve
    if (offset <=0 ) {
      // offset is also -ve

      if ((Long.MIN_VALUE-address)-offset<=0) {
       //   System.out.println("Point xxx5:" + address + ":" + offset);
         address = offset+address; // makes it smaller!!!
      }
      else {
       // System.out.println("Point xxx6:" + address + ":" + offset);
        address = Long.MAX_VALUE-((Long.MIN_VALUE-address)-offset)+1;
      }

    } // end of if
    else {
      // its a positive offset so we could go over top of memory
      // lets see how far we are away from 8allzeros
      if ((address-Long.MIN_VALUE) < offset) {
        // we have enough space
         // I know it looks strange taking the offset
        // away but its actually making the address bigger!!!!
        // i.e. closer to 8allzeroes
        //System.out.println("Point xxx7:" + address + ":" + offset);
        address = address-offset;

      }
      else {
         //System.out.println("Point xxx8:" + address + ":" + offset);
         DvAddressException ex =
           new DvAddressException("New DvAddress would exceed 64bit boundary");

         throw ex;

      }
    }

   } // end of else

 } // end of method

 /**
  *   <p>Description: returns true if 2 addresses are equal
  *   </p>
  */
 public  boolean equals(DvAddress x) {

   if (this.address == x.getAddressAsLong()) return true;
   else return false;
 }




}
