/*
 * @(#)src/classes/sov/com/ibm/jvm/dump/SDFFJStackTr.java, ras, dumpviewer 1.3
 * ===========================================================================
 * IBM Confidential
 * OCO Source Materials
 *
 * IBM Java(tm)2 SDK, Standard Edition, v 1.3.1
 * (C) Copyright IBM Corp. 1998, 2001.
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright office.
 * ===========================================================================
 */

/*
 *
 * ===========================================================================
 *
 *
 *
 * ===========================================================================
 * Change activity:
 *
 * Reason  Date   Origin  Description
 * ------  ----   ------  ----------------------------------------------------
 * 41452  210502 nmasson  New

 *
 * ===========================================================================
 * Module Information:
 *
 * DESCRIPTION:
 * ===========================================================================
 */
package com.ibm.jvm.dump;


 /**
  *  IBM.FIXME Just a skeleton so far
  *
  */
import java.io.*;



class SDFFJStackTr  extends DvJStackTR {

    private byte[] metadata;
    private long   metadata_offset;
    private long   frameid;
    private long   methodblock;
    private long   lastpc;
    private long   argsptr;
    private long   varsptr;
    private long   is_JIT_frame;

    /**
     *   <p>Description: Load a SDFFJStackTr object from an SDFFFile
     *   </p>
     */
    public static  SDFFJStackTr loadFromFile(long o,RandomAccessFile raf) {

        DvUtils.trace("Entry to SDFFJStackTr:loadFromFile...",0,false);
        long offset_in_file = o; // This is offset of envdata subsection
        DvUtils.trace("  .... Loading SDFFRegister object from file :"+o,
                        0,false);
        SDFFJStackTr jStack = new SDFFJStackTr();

        try {
            raf.seek(offset_in_file);
            long length=raf.readLong();
            raf.skipBytes(8); // skip the eyecatcher (assumed caller has already verified)

            raf.seek(offset_in_file+length-8);
            jStack.metadata_offset = raf.readLong();
            if (-1 != jStack.metadata_offset) {
                    // if theres some metadata
                    //System.out.println("emdo:"+envData.metadata_offset+":"+length);
                    jStack.metadata = new byte[(int)(jStack.metadata_offset)];
                    raf.seek(offset_in_file+length-8-jStack.metadata_offset);
                    raf.read(jStack.metadata);
                    String s = new String(jStack.metadata);
                    System.out.println("jstackmd:"+s);
            }

            raf.seek(offset_in_file+16); // start + len + eyecatcher

            jStack.frameid = raf.readLong();
            jStack.methodblock = raf.readLong();
            jStack.lastpc = raf.readLong();
            jStack.argsptr = raf.readLong();
            jStack.varsptr = raf.readLong();
            jStack.is_JIT_frame = raf.readLong();

        }
        catch (IOException e) {
            DvUtils.errorMsg("IOException in SDFFJStackTr: loadFromFile",0);
        }



        DvUtils.trace("Exit from SDFFJStackTr:loadFromFile",0,false);
        return jStack;
    }


    void printSdff(Sdff sdff) throws IOException {
        long start = sdff.getFilePointer();
        sdff.writeLong(0);
        sdff.writeBytes(new String("JSTACKTR"));
        sdff.writeLong(-1l); //IBM.FIXME need actual values
        sdff.writeLong(-1l);
        sdff.writeLong(-1l);
        sdff.writeLong(-1l);
        sdff.writeLong(-1l);
        sdff.writeLong(-1l);
        // Add padding
        for(int i=0; i<8; i++) {
            sdff.writeBytes("PAD ");
        }
    // Write metadata
        sdff.writeLong(-1l);
        sdff.printLength(start);
    }

}
