/*
 * @(#)src/classes/sov/com/ibm/jvm/dump/SDFFLoaded.java, ras, dumpviewer 1.4
 * ===========================================================================
 * IBM Confidential
 * OCO Source Materials
 *
 * IBM Java(tm)2 SDK, Standard Edition, v 1.3.1
 * (C) Copyright IBM Corp. 1998, 2001.
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright office.
 * ===========================================================================
 */

/*
 *
 * ===========================================================================
 *
 *
 *
 * ===========================================================================
 * Change activity:
 *
 * Reason  Date   Origin  Description
 * ------  ----   ------  ----------------------------------------------------
 * 36524  020502  PHILR:  New for feature 36524
 *
 *
 * ===========================================================================
 * Module Information:
 *
 * DESCRIPTION:
 * ===========================================================================
 */

package com.ibm.jvm.dump;

import java.io.*;
import java.util.*;

 /**
  *  Description: Whats the purpose of this class
  *
  *
  *
  *
  *
  */
public class SDFFLoaded extends DvLoaded {


    private byte[] metadata;
    private long   metadata_offset;
    Vector modules = new Vector();


    public DvModule[] getModules()  {


        if (modules.size() > 0) {
            DvModule[] m = new DvModule[modules.size()];
            for (int i=0;i<modules.size();i++) {
                m[i] = (DvModule) modules.get(i);
            }
            return m;
        }
        else {
            return null;
        }

    }

    public byte[] getMetadata() {return null;}

    /**
     *   <p>Description: Load an EnvData object from an SDFFFile
     *   </p>
     */
    public static SDFFLoaded loadFromFile(long o,RandomAccessFile raf) {

        DvUtils.trace("Entry to SDFFLoaded:loadFromFile...",0,false);
        long offset_in_file = o; // This is offset of loaded subsection
        SDFFLoaded loaded = new SDFFLoaded();

        try {
            raf.seek(offset_in_file);
            long length = raf.readLong();
            DvUtils.trace("/tOffest of loaded subsection is "+offset_in_file+
                  " :  length=" + length  ,0,false);

            // first we deal with any metadata
            raf.seek(offset_in_file+length-8);
            loaded.metadata_offset = raf.readLong();
            if (-1 != loaded.metadata_offset) {
                    // if theres some metadata
                    //System.out.println("emdo:"+envData.metadata_offset+":"+length);
                    loaded.metadata = new byte[(int)(loaded.metadata_offset)];
                    raf.seek(offset_in_file+length-8-loaded.metadata_offset);
                    raf.read(loaded.metadata);
                    //String s = new String(envData.metadata);
                    //System.out.println("emdo:"+s);
            }

            // Now see if there was anything left after considering metadata
            long real_data_length = length - 24 ;


            if (real_data_length > 0) {
                raf.seek(offset_in_file+16);

                // above sek skipped straight to the meat......
                // (assumed caller has already verified eyecatcher)
                // Now we go through the rest of bytes until we reach metadata...
                // so firstly lets figure out where metadata is ....

                boolean bDone=false;
                boolean bFormatError = false;

                while (false == bDone && false == bFormatError) {
                    // read each oaded module until we have finished
                    // first where its loaded to (a Long)
                    try {

                        long modAddr = raf.readLong();
                        long modSize = raf.readLong();
                        int modnameSize=(int) raf.readLong();
                        String modName = "";
                        if (modnameSize > 0) {
                            byte[] baName = new byte[modnameSize];
                            raf.read(baName);
                            modName = new String(baName);
                        }
                        DvModule m = new DvModule(new DvAddress(modAddr),
                                modName,modSize,0);
                        loaded.modules.add(m);
                        int hack = modnameSize%8;
                        if (hack >0) {

                            byte[] baHack = new byte[8-hack];
                            raf.read(baHack);
                        }
                        //System.out.println("aaa:"+raf.getFilePointer()+
                        //                    ":"+offset_in_file + ":" +
                        //                    real_data_length);
                        if (raf.getFilePointer() >=
                             (offset_in_file+real_data_length+16))
                        {
                            bDone = true;
                        }

                    }
                    catch  (Exception e1) {
                        DvUtils.errorMsg("Exception in SDFFLoaded: loadFromFile " +
                          "(format error whilst loading module names/addresses)",0);
                        String s = e1.getMessage();
                        if (null != s) System.out.println(s);
                        e1.printStackTrace(System.out);
                        bFormatError = true;
                        bDone = true;
                    }
                    catch (Error err) {
                        DvUtils.errorMsg("Error in SDFFLoaded: loadFromFile " +
                          "(format error whilst loading module names/addresses)",0);
                        String s = err.getMessage();
                        if (null != s) System.out.println(s);
                        err.printStackTrace(System.out);
                        bFormatError = true;
                        bDone = true;
                    }



                }
                DvModule m = null;
                DvAddress a=null;
                String modName=null;
                long modSize = 0;

                //boolean finished = false;
                //while (false == finished) {
                // formulate a new DvModule by reading from file
                // finished when we reach metadata (or above....)


                //  m = new DvModule(a,modName,modSize);

                //}
            }

        }
        catch (IOException e) {
            DvUtils.errorMsg("IOException in SDFFLoaded: loadFromFile",0);
            String s = e.getMessage();
            if (null != s) System.out.println(s);
                e.printStackTrace(System.out);
        }


        DvUtils.trace("Exit from SDFFLoaded:loadFromFile...",0,false);
        return loaded;
    }





}
