/*
 * @(#)src/classes/sov/com/ibm/jvm/dump/SDFFMemRanges.java, ras, dumpviewer 1.6
 * ===========================================================================
 * IBM Confidential
 * OCO Source Materials
 *
 * IBM Java(tm)2 SDK, Standard Edition, v 1.3.1
 * (C) Copyright IBM Corp. 1998, 2001.
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright office.
 * ===========================================================================
 */

/*
 *
 * ===========================================================================
 *
 *
 *
 * ===========================================================================
 * Change activity:
 *
 * Reason  Date   Origin  Description
 * ------  ----   ------  ----------------------------------------------------
 * 36524  020502 PHILR:  New for feature 36524
 * 36524  030702 philr   Tidy up, add trace,fix metadata bug
 *
 * ===========================================================================
 * Module Information:
 *
 * DESCRIPTION:
 * ===========================================================================
 */


package com.ibm.jvm.dump;

import java.io.*;

 /**
  *  Description: Whats the purpose of this class
  *
  *
  *
  *
  *
  */
public class SDFFMemRanges extends DvMemRanges {

    // the data associated with the SDffMemRanges is
    // Note the data is all static so that it can be loaded without instantiation

    private long memory_id;  // currently not used
    private long spare;      // currently not used
    private long start_address;
    private long memory_length;
    private long offset;
    private long flags1; // currently not used
    private long flags2; // currently not used
    private long flags3; // currently not used




    /**
     *
     */
    public  DvAddress addressStart() {


        SDFFAddress a = new SDFFAddress();
        a.setAddress(start_address);
        return a;
    }

    /**
     *
     */
    public  long length() {return memory_length ;}

    /**
     *
     */
    public byte[] getMetadata() {return null;};

    /**
     *
     */
    public long getOffset() {return offset;}

    /**
     *
     */
    public static  int getSize() {
        return 64 ;
    }

    /**
     *
     */
    public static int countThem(long offset,long length,RandomAccessFile raf) {

        int count=0;
        // count is (length - sizeof an SddfStd segment- size of any metadata)/
        // space taken by 8 java longs (64 bytes)

        // so first we go to the end of this segment and see whether we have java long -1
        // as the offset of metadata - if we do then we don't have any metadata and only have
        // to remove 8, otherwise we have to go to top of metadata (which will hopefully
        // contain the metadata eyecatcher!!!)
        DvUtils.trace("Entry SDFFMemRanges:countThem - offset = "+
                        offset + "  length= " + length,0,false);
        long work_offset = offset+length-8;
        boolean bIsMetaData=true; // assume metadata until proved otherwise.

        try {

            raf.seek(work_offset);

            work_offset = raf.readLong();

            if (0 >= work_offset) {
                bIsMetaData=false;
            }
            else {
                byte[] bytes = new byte[8];
                raf.seek(work_offset);
                raf.read(bytes,0,8);
                String eye = new String(bytes);

                if (eye.equals(SdffConstants.SEGMENT_Eye_SdffMeta) != true) {
                    DvUtils.trace(  "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!" +
                                    "\n!!! SDFFMemRanges:countThem      !!!" +
                                    "\n!!! METADATA Eyecatcher not nice !!!" +
                                    "\n!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!",
                                    0,true);

                }
                bIsMetaData=true;
            }
        }
        catch (IOException ioe) {
            System.out.println("!!!!! IOEXception out of SDFFMemRanges:countThem");
            bIsMetaData = false;
        }


        if (true == bIsMetaData) {
            count = (int)(length - SdffStd.getSize()) ;
            count = count - (int) ((offset + length)-work_offset);
        }
        else {
            count = (int)(length - SdffStd.getSize() - 8);
        }
        count = count/SDFFMemRanges.getSize();



        DvUtils.trace("Exit SDFFMemRanges:countThem - count = "+
                count, 0,false);
        return count;
    }

    /**
     *
     */
    public void loadFromFile(long o ,long length,RandomAccessFile raf,long i) {

        // So we have to step over the header off offset
        // and then we need to read 8 longs as per above
        long offset_in_file = o  + SdffStd.getSize() + i*(SDFFMemRanges.getSize());

        try {
            raf.seek(offset_in_file);
            memory_id = raf.readLong();  // currently not used
            spare = raf.readLong();     // currently not used
            start_address = raf.readLong();
            memory_length = raf.readLong();
            offset = raf.readLong();
            flags1 = raf.readLong(); // currently not used
            flags2 = raf.readLong(); // currently not used
            flags3 = raf.readLong(); // currently not used

        }
        catch (IOException e) {
            DvUtils.trace(  "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!" +
                            "\n!!! SDFFMemRanges:loadFromFile   !!!" +
                            "\n!!! METADATA Eyecatcher not nice !!!" +
                            "\n!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!",
                            0,true);

        }
        DvUtils.trace(  "Memory range "+i+ "address: x"+
                        Long.toHexString(start_address)+
                        "  len: "+memory_length + "  offset: x"+
                        Long.toHexString(offset_in_file),0,false);

    }
}
