/*
 * @(#)src/classes/sov/com/ibm/jvm/dump/SDFFRegister.java, ras, dumpviewer 1.3
 * ===========================================================================
 * IBM Confidential
 * OCO Source Materials
 *
 * IBM Java(tm)2 SDK, Standard Edition, v 1.3.1
 * (C) Copyright IBM Corp. 1998, 2001.
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright office.
 * ===========================================================================
 */

/*
 *
 * ===========================================================================
 *
 *
 *
 * ===========================================================================
 * Change activity:
 *
 * Reason  Date   Origin  Description
 * ------  ----   ------  ----------------------------------------------------
 * 41452  210502 nmasson  New
 * 36524  240702  philr   Expanded for 36524
 *
 * ===========================================================================
 * Module Information:
 *
 * DESCRIPTION:
 * ===========================================================================
 */
package com.ibm.jvm.dump;




import java.io.*;
import java.util.*;

class SDFFRegister extends DvRegister {

    private  Vector names = new Vector();
    private  Vector values = new Vector();
    private  long count;
    private  long size;


    /**
     *    Get address of a register
     *
     */
    public DvAddress getAddressValue() {
        return null;
    }

    /**
     *  gets a String value for this set of registers
     *
     */
    public String getStringValue() {

        String retString = "";

        Vector v = new Vector();
        for (int i=0;i<count;i++) {
           String value = Long.toHexString(((Long) values.get(i)).longValue());
           while (value.length() != 2*size) {
                    value = "0" + value;
           }
           String s =  (String) names.get(i) + value;

           v.add(s);

        }
        Collections.sort(v);
        for (int i=0;i<count;i++) {

            if (0 == i%4) {
                retString += "\n   ";
            }

            retString = retString + (String) v.get(i);


        }

        if (retString.equals("")) {
            retString = "\n  --- No register data for this thread --- \n";
        }
        return retString;
    }

    /**
     *    Getregister description
     *
     */
    public String description()  {
        return("");
    } // e.g. "SP" for stack pointer

    /**
     *    Code to fill a register area
     *
     */
    void printSdff(Sdff sdff) throws IOException {
        long start = sdff.getFilePointer();
        sdff.writeLong(0);
        sdff.writeBytes(new String("REGISTER"));
        sdff.writeLong(0l); //IBM.FIXME implement this
        sdff.writeLong(0l);
        sdff.writeLong(0l);
        sdff.writeLong(0l);
    // Write Metadata
        sdff.writeLong(-1l);
        sdff.printLength(start);
    }



    /**
     *   <p>Description: Load a Register object from an SDFFFile
     *   </p>
     */
    public static  SDFFRegister loadFromFile(long o,RandomAccessFile raf) {

        DvUtils.trace("Entry to SDFFRegister:loadFromFile...",0,false);
        long offset_in_file = o; // This is offset of envdata subsection
        DvUtils.trace("  .... Loading SDFFRegister object from file :"+o,
                        0,false);
        SDFFRegister regSection = new SDFFRegister();

        try {
            raf.seek(offset_in_file);
            long length=raf.readLong();
            raf.skipBytes(8); // skip the eyecatcher (assumed caller has already verified)
            regSection.count=raf.readLong();

            regSection.size = raf.readLong();
            DvUtils.trace("  .... count of registers in this section is:"+
                            regSection.count +
                            " with size "+ regSection.size,0,false);
            if (regSection.size != 4 &&
                regSection.size != 8 &&
                regSection.size != 16) {
                // hack
                regSection.count =0;
                regSection.size = 0;
            }

            for (int i=0;i<regSection.count;i++) {
                byte[] name = new byte[8];
                raf.read(name);
                String s = new String(name);
                long value = raf.readLong();
                //System.out.println(" Reg name is:"+s+ "with value: "+
                //        Long.toHexString(value));
                regSection.names.add(s);
                regSection.values.add(new Long(value));

            }
            //System.out.println(regSection.getStringValue());



        }
        catch (IOException e) {
            DvUtils.errorMsg("IOException in SDFFThread: loadFromFile",0);
        }



        DvUtils.trace("Exit from SDFFRegister:loadFromFile",0,false);
        return regSection;
    }


 }


