/*
 * @(#)src/classes/sov/com/ibm/jvm/dump/Sdff.java, ras, dumpviewer 1.4    
 * ===========================================================================
 * IBM Confidential
 * OCO Source Materials
 *
 * IBM Java(tm)2 SDK, Standard Edition, v 1.3.1
 * (C) Copyright IBM Corp. 1998, 2001.
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright office.
 * ===========================================================================
 */

/*
 *
 * ===========================================================================
 *
 *
 *
 * ===========================================================================
 * Change activity:
 *
 * Reason  Date   Origin  Description
 * ------  ----   ------  ----------------------------------------------------
 * 41452  210502 nmasson  New

 *
 * ===========================================================================
 * Module Information:
 *
 * DESCRIPTION:
 * ===========================================================================
 */
package com.ibm.jvm.dump;


 /**
  *  SDFF encpasulates the SDFF file
  *
  */

import java.lang.*;
import java.io.*;
import java.util.*;

public class Sdff extends RandomAccessFile {
    /**
     * Holds offsets to super to be updated
     */
    Vector fixup;
    private static byte[] pad = { 0, 0, 0, 0, 0, 0, 0, 0 };


    /**
     * Constructs an SDFF file with read-write permissions
     */
    Sdff(String name) throws FileNotFoundException {
	super(name, "rw");
	fixup = new Vector(20);
    }
    /**
     * prints the length of a section, from start to the current file
     * offset at offset start.  The current file offset is restored
     */
    void printLength(long start) throws IOException {
	long end = super.getFilePointer();
	super.seek(start);
	super.writeLong(end-start);
	super.seek(end);
    }
    /**
     * aligns to an align-byte boundary
     */
    void align(int align) throws IOException {
	long pos = getFilePointer();
        int bytes = (int)((pos + align - 1) / align * align - pos);
        if (bytes > 0) {
            write(pad, 0, bytes);
        }
    }

    /**
     * destructively goes throiugh the list of Fixups updating the
     * pointer at each Fixup file offset with location within the SDFF 
     * file of the associated super
     */
    void fixupMap() throws IOException {
	long memoryStart = super.getFilePointer();
	Enumeration list = fixup.elements();
	while(list.hasMoreElements()) {
	    Fixup fix = (Fixup)list.nextElement();
	    super.seek(fix.offset);
	    super.writeLong(fix.value + memoryStart);
	    DvUtils.trace("Fixup offset " + 
		Long.toHexString(fix.offset) + " from " +
		Long.toHexString(fix.value) + " to " +
		Long.toHexString(fix.value + memoryStart), 2, false);
	}
	super.seek(memoryStart);
	fixup.removeAllElements();
    }
}
