/*
 * @(#)src/classes/sov/com/ibm/jvm/dump/Segment.java, ras, dumpviewer 1.3
 * ===========================================================================
 * IBM Confidential
 * OCO Source Materials
 *
 * IBM Java(tm)2 SDK, Standard Edition, v 1.3.1
 * (C) Copyright IBM Corp. 1998, 2001.
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright office.
 * ===========================================================================
 */

/*
 *
 * ===========================================================================
 *
 *
 *
 * ===========================================================================
 * Change activity:
 *
 * Reason  Date   Origin  Description
 * ------  ----   ------  ----------------------------------------------------
 * 41452  210502 nmasson  New

 *
 * ===========================================================================
 * Module Information:
 *
 * DESCRIPTION:
 * ===========================================================================
 */
package com.ibm.jvm.dump;


 /**
  *
  */

import java.io.*;

class Segment extends DvModule {
    DvReader reader;
    long offset;
    byte[] flags;

    Segment(String name, long address, long length, int type) { 
	super(new SDFFAddress(address), name, length, type);
	flags = new byte[24];
    }
    Segment(String name, long address, long length, int type, 
	DvReader reader, long offset) {
	this(name, address, length, type);
	this.offset = offset;
	this.reader = reader;
    }
    Segment() {}
    void printSdff(Sdff sdff) throws IOException {
	if(reader != null) {
	    sdff.writeLong(0l);
            sdff.writeLong(0l);
            sdff.writeLong(moduleAddress.getAddressAsLong());
            sdff.writeLong(moduleSize);
	    // Need to fix up the address in the output file later
	    long outputfileOffset = sdff.getFilePointer();
	    sdff.fixup.addElement(new Fixup(outputfileOffset, offset));
            sdff.writeLong(0l);
            sdff.writeBytes(new String(flags));
	}
    }
    void printMemory(Sdff sdff) throws IOException {
	int bufferSize = 4096;
	if(reader != null) {
	    long dataSize = moduleSize;
	    byte[] buffer = new byte[bufferSize];
	    while(dataSize > bufferSize) {
		reader.read(buffer);
		sdff.write(buffer);
	    	dataSize -= bufferSize;
	    }
	    // Read the rest
	    if(dataSize > 0) {
		reader.read(buffer, 0, (int)dataSize);
		sdff.write(buffer, 0, (int)dataSize);
	    }
	}
    }
    void printSdffLoaded(Sdff sdff) throws IOException {
	DvUtils.trace("Text:("+ moduleName + ") " + 
	    Long.toHexString(moduleAddress.getAddressAsLong()), 2, false);
	if(!moduleName.equals("")) {
	    sdff.writeLong(moduleAddress.getAddressAsLong());
	    sdff.writeLong(moduleSize);
	    // Round the name to an 8 byte boundary
	    int size = ((moduleName.length() - 1) / 8 + 1) * 8;
	    sdff.writeLong(moduleSize);
	    sdff.writeBytes(moduleName);
	    int rem = size - moduleName.length();
	    if (rem > 0) {
		String align = "        ".substring(0, rem);
		sdff.writeBytes(align);
	    }
	}
    }
}
