/*
 * @(#)src/classes/sov/com/ibm/jvm/dump/XHPIModule.java, ras, dumpviewer 1.4    
 * ===========================================================================
 * IBM Confidential
 * OCO Source Materials
 *
 * IBM Java(tm)2 SDK, Standard Edition, v 1.3.1
 * (C) Copyright IBM Corp. 1998, 2001.
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright office.
 * ===========================================================================
 */

/*
 *
 * ===========================================================================
 *
 *
 *
 * ===========================================================================
 * Change activity:
 *
 * Reason  Date   Origin  Description
 * ------  ----   ------  ----------------------------------------------------
 * 41452  210502 nmasson  New

 *
 * ===========================================================================
 * Module Information:
 *
 * DESCRIPTION:
 * ===========================================================================
 */
package com.ibm.jvm.dump;


 /**
  *
  */

import java.util.*;
import java.io.*;

class XHPIModule {
    long envPtr;
    long loadedPtr;
    String sysName;
    String nodeName;
    String release;
    String kVersion;
    String machine;
    String libc;

    XHPIModule(DvFileReader reader, ExProcess process) 
		throws IOException {
	DvUtils.trace("populate XHPIModule", 0, false);
	long address = process.hpiData.pfmData;
	address += 8 + 4*4;			// IBM.FIXME read 4 ints
	reader.setAddress(address);
	DvUtils.trace("Set address " + Long.toHexString(address), 2, false);
        envPtr = reader.readAddress();
	sysName = reader.readStringPtr();
	nodeName = reader.readStringPtr();
	release = reader.readStringPtr();
	kVersion = reader.readStringPtr();
	machine = reader.readStringPtr();
	libc = reader.readStringPtr();
	DvUtils.trace("sysName = " + sysName, 1, false);
	DvUtils.trace("nodeName = " + nodeName, 1, false);
	DvUtils.trace("release = " + release, 1, false);
	DvUtils.trace("kVersion = " + kVersion, 1, false);
	DvUtils.trace("machine = " + machine, 1, false);
	DvUtils.trace("libc = " + libc, 1, false);
        loadedPtr = reader.getPos();
	DvUtils.trace("envPtr=" + Long.toHexString(envPtr), 1, false);
	DvUtils.trace("loadedPtr=" + Long.toHexString(loadedPtr), 1, false);

	ExEnvData env = new ExEnvData(reader, envPtr);
	ExLoaded loaded = new ExLoaded(reader, loadedPtr);
	process.environment = env;
	process.loaded = loaded;
    }
}    
