package com.ibm.jvm.findroots;


/**
 *  This interface is used by objects that scan heap dumps to report back on what they find.
 *  It is an event-based push model similar to SAX.
 *  @author David Griffiths <tt>&lt;dave@prim.demon.co.uk&gt;</tt>
 */

public interface HeapdumpContentHandler {
    public void instanceDump(int id, String className, int references[], int size);
    public void classDump(int id, String className, int references[], int size);
    public void objectArrayDump(int id, String className, int references[], int size);
    public void primitiveArrayDump(int id, int type, int size);
    public void error(String msg);
    public void log(String msg);
    public void addEdge(int fromId, int toId);
}
