package com.ibm.jvm.findroots;

import java.io.*;
import java.util.*;

/**
 *  This class simply prints the contents of the heap dump.
 *
 *  @author David Griffiths <tt>&lt;dave@prim.demon.co.uk&gt;</tt>
 */

public class Print extends PrintBase {

    public static void main(String args[]) {
        Print print = new Print();
        print.start(args, "Print");
    }

    void parseEnd() {
        System.out.println("total count " + totalCount + " total size " + totalSize);
    }

    public void objectDump(int id, int index, int flags, int size, int refs[]) {
        super.objectDump(id, index, flags, size, refs);
        System.out.println("object " + hex(id) + " " + getString(index));
    }

    public void classDump(int id, int index, int flags, int size, int refs[]) {
        super.classDump(id, index, flags, size, refs);
        System.out.println("class " + hex(id) + " " + getString(index));
    }

    public void primitiveArrayDump(int id, int type, int flags, int size) {
        super.primitiveArrayDump(id, type, flags, size);
        System.out.println("primarray " + hex(id) + " " + type);
    }

    public void objectArrayDump(int id, int index, int flags, int size, int refs[]) {
        super.objectArrayDump(id, index, flags, size, refs);
        System.out.println("objarray " + hex(id) + " " + getString(index));
    }
}

