package com.ibm.jvm.findroots;

import java.io.*;
import java.util.*;
import com.ibm.jvm.util.*;

/**
 *  This class prints the reachability from a given class of objects.
 *
 *  @author David Griffiths <tt>&lt;dave@prim.demon.co.uk&gt;</tt>
 */

public class PrintClassReach extends PrintBase {

    String className;

    public static void main(String args[]) {
        PrintClassReach pc = new PrintClassReach();
        pc.start(args, "PrintClassReach");
    }

    String[] options() {
        return new String[] {"-class <classname>"};
    }

    String[] optionDescriptions() {
        return new String[] {
            "\tSpecify the class whose reachability is to be printed"
        };
    }

    public boolean parseOption(String arg, String opt) {
        if ("-class".equals(arg)) {
            className = opt;
            return true;
        }
        return super.parseOption(arg, opt);
    }

    void parseStart() {
        if (className == null)
            usage();
    }

    void parseEnd() {
        int reach = 0;
        for (int i = 0; i < ids.size(); i++) {
            int id = ids.get(i);
            if (getName(id).equals(className)) {
                reach += graph.reachFrom(id);
            }
        }
        System.out.println("reachability = " + reach);
    }
}

