package com.ibm.jvm.findroots;

import java.io.*;
import java.util.*;
import com.ibm.jvm.util.*;

/**
 *  This class prints the class tree.
 *
 *  @author David Griffiths <tt>&lt;dave@prim.demon.co.uk&gt;</tt>
 */

public class PrintClassTree extends PrintBase {

    int depth;

    public static void main(String args[]) {
        PrintClassTree tree = new PrintClassTree();
        tree.start(args, "PrintClassTree");
    }

    void parseEnd() {
        NewGraph classGraph = new NewGraph();
        classGraph.idToIndex(0);
        for (int i = 0; i < ids.size(); i++) {
            int v = ids.get(i);
            int classi = classId(i);
            classGraph.addToVertex(classi, 1);
            for (IntEnumeration e = graph.getChildren(v); e.hasMoreElements(); ) {
                int u = e.nextInt();
                int ui = ids.indexOf(u);
                if (ui == -1) {
                    System.out.println("Warning! could not resolve reference 0x" + hex(u));
                    continue;
                }
                int classu = classId(ui);
                classGraph.addEdge(classi, classu);
            }
        }
        classGraph.printDomTree(this);
    }

    public String getName(int id) {
        return getClassName(id);
    }
}
