package com.ibm.jvm.findroots;

import java.io.*;
import java.util.*;
import com.ibm.jvm.util.*;

/**
 *  This class does a crude find roots print.
 *
 *  @author David Griffiths <tt>&lt;dave@prim.demon.co.uk&gt;</tt>
 */

public class PrintRoots extends PrintBase {

    public static void main(String args[]) {
        PrintRoots roots = new PrintRoots();
        roots.start(args, "PrintRoots");
    }

    String[] options() {
        return new String[] {"-excludeobject <addr>", "-excludeclass <name>"};
    }

    String[] optionDescriptions() {
        return new String[] {
            "\tExclude object with this address (hex)",
            "\tExclude all objects of this class (eg java/lang/Object)"
        };
    }

    void parseEnd() {
        graph.print(this);
    }
}

