package com.ibm.jvm.findroots;

import java.io.*;
import java.util.*;
import com.ibm.jvm.util.*;

/**
 *  This class prints the given root.
 *
 *  @author David Griffiths <tt>&lt;dave@prim.demon.co.uk&gt;</tt>
 */

public class PrintTree extends PrintBase {

    int root = -1;
    int maxdepth = 50;
    int prune = 100;

    public static void main(String args[]) {
        PrintTree tree = new PrintTree();
        tree.start(args, "PrintTree");
    }

    String[] options() {
        return new String[] {"-root <n>"};
    }

    String[] optionDescriptions() {
        return new String[] {
            "\tSpecify which root to print (in hex)"
        };
    }

    public boolean parseOption(String arg, String opt) {
        if ("-root".equals(arg)) {
            try {
                root = Integer.parseInt(opt, 16);
            } catch (Exception e) {
                System.err.println(opt + " is not a valid number");
                usage();
            }
            return true;
        }
        return super.parseOption(arg, opt);
    }

    void parseStart() {
        if (root == -1)
            usage();
    }

    void parseEnd() {
        graph.print(this, root);
    }
}

