package com.ibm.jvm.findroots;

/**
 * This class defines a Vertex.
 */

public class Vertex extends Base {
    /** The NewGraph object that this vertex belongs to */
    protected NewGraph graph;
    /** The index of this vertex within the NewGraph object */
    protected int index;

    String className() {
        return "Vertex";
    }

    /**
     * Create a new Vertex.
     */
    protected Vertex(NewGraph graph, int index) {
        this.graph = graph;
        this.index = index;
    }

    /**
     * Return the total number of vertices that are reachable from this one.
     */
    public int reachableVertices() {
        return graph.reachableVertices(index);
    }

    /**
     * Return the total size occupied by all the vertices that are reachable from this one.
     */
    public int reachableSize() {
        return graph.reachableSize(index);
    }
}
