package com.ibm.jvm.svcdump;

import java.util.*;
import com.ibm.jvm.dump.*;

/**
 *  Description: Whats the purpose of this class
 */
public class Process extends DvProcess {

    AddressSpace addressSpace;

    /* Start of DvProcess methods */

    /**
     *
     *
     */
    public DvAddressSpace getAddressSpace() {
        return addressSpace;
    }

    /**
     *   Description:
     *
     */
    public String id() {
        return addressSpace.id();
    }

    /**
     *   Description:
     *
     */
    public DvThread[] getThreads() {
        Tcb t[] = addressSpace.tcbs();

        if (t == null)
            return new DvThread[0];
        Vector v = new Vector();

        for (int i = 0; i < t.length; i++) {
            Tcb tcb = t[i];

            if (tcb.isKnownType()) {
                v.add(tcb);
            }
        }
        DvThread threads[] = (DvThread[]) v.toArray(new DvThread[0]);

        return threads;
    }

    /**
     *   Description:
     *
     */
    public boolean isJava() {
        Tcb t[] = addressSpace.tcbs();

        if (t == null)
            return false;
        for (int i = 0; i < t.length; i++) {
            Tcb tcb = t[i];

            if (tcb.isJava()) {
                return true;
            }
        }
        return false;
    }

    /**
     *   Description:
     *
     */
    public String getSignal() {
        return "Unknown";
        //throw new Error("unimplemented method");
    }

    /**
     *   Description:
     *
     */
    public DvThread getCurrentThread() {
        return null;
    }

    /**
     *   Description:
     *
     */
    public DvEnvData getEnvData() {
        return null;
    }

    /**
     *   Description:
     *
     */
    public DvLoaded getLoaded() {
        throw new Error("unimplemented method");
    }

    /* End of DvProcess methods */

    /**
     *   Description:
     *
     */
    Process(AddressSpace addressSpace) {
        this.addressSpace = addressSpace;
    }
}
