package com.ibm.jvm.svcdump;

import java.io.*;
import java.util.*;

/**
 *  This class represents an MVS System Trace Table Entry.
 */

public class TraceEntry implements Serializable {

    int type;
    int psw;
    long timestamp;
    static final long epoch = ((70 * 365) + 17) * 24 * 3600 * 1000;

    TraceEntry(int type, int psw, long timestamp) {
        this.type = type;
        this.psw = psw;
        this.timestamp = timestamp;
    }

    Date getDate() {
        long tod = timestamp >>> 12;
        tod /= 1000;
        tod -= epoch;
        Date d = new Date(tod);
        return d;
    }
}

