package com.ibm.jvm.util;

import com.ibm.jvm.util.*;

public final class IntegerStack {
    IntegerArray stack = new IntegerArray();
    int depth;

    public void push(int n) {
        if (depth == stack.size()) {
            stack.add(n);
            depth++;
        } else {
            stack.put(depth++, n);
        }
    }

    public int pop() {
        return stack.get(--depth);
    }

    public int peek() {
        return stack.get(depth - 1);
    }

    public boolean empty() {
        return depth == 0;
    }

    public int size() {
        return stack.size();
    }

    public int depth() {
        return depth;
    }

    public void reset() {
        depth = 0;
    }
}
