package com.ibm.jvm.util;


import java.io.IOException;


/**
 *  This is similar to a RandomAccessFile and can be used for things like accessing memory.
 *  @author David Griffiths <tt>&lt;dave@prim.demon.co.uk&gt;</tt>
 */

public interface RandomAccessStream {
    public void seek(long pos) throws IOException;
    public int readInt(long pos) throws IOException;
    public int readInt() throws IOException;
    public byte readByte(long pos) throws IOException;
    public byte readByte() throws IOException;
    public int readUnsignedByte(long pos) throws IOException;
    public int readUnsignedByte() throws IOException;
}
