package com.ibm.jvm.util.html;

import java.util.*;

/**
 *  This class is the root of all the HTML classes.
 *
 *  @author David Griffiths <tt>&lt;dave@prim.demon.co.uk&gt;</tt>
 */

public class Element extends Base {
    /** The containing html document object. */
    protected Document document;
    /** The optional comment string. */
    protected String comment;

    /**
     * Set the containing html document. 
     */
    public void setDocument(Document document) {
        this.document = document;
    }

    /**
     * Set the comment string
     */
    public void setComment(String comment) {
        this.comment = comment;
    }

    /**
     * Beautify the html by adding the optional comment and newline.
     */
    protected String beautify(String s) {
        String r = s;
        if (comment != null) {
            r += " <!-- " + comment + " -->";
        }
        return r + Document.lineSeparator;
    }

    /**
     * Returns a html representation of this element.
     */
    protected String toHtmlString() {
        assert(false);
        return null;
    }

    /**
     * Returns a text representation of this element.
     */
    protected String toTextString() {
        assert(false);
        return null;
    }
}
