package com.ibm.jvm.zseries;


/**
 *  @author David Griffiths <tt>&lt;dave@prim.demon.co.uk&gt;</tt>
 */

public class BranchOnConditionR extends RRInstruction {

    BranchOnConditionR(Engine engine, int word) {
        super(engine, word);
    }

    public String mnemonic() {
        String s = null;

        switch (r1()) {
        case 1:
            s = "BO ";
            break;

        case 2:
            s = "BGT";
            break;

        case 3:
            s = "BC ";		// carry
            break;

        case 4:
            s = "BLT";
            break;

        case 5:
            s = "BNZ";		// not zero
            break;

        case 7:
            s = "BNE";
            break;

        case 8:
            s = "BEQ";
            break;

        case 10:
            s = "BZ ";		// zero
            break;

        case 11:
            s = "BGE";
            break;

        case 12:
            s = "BNC";		// no carry
            break;

        case 13:
            s = "BLE";
            break;

        case 14:
            s = "BNO";
            break;

        case 15:
            s = "B  ";
            break;

        default:
            throw new Error("Unknown branch mask " + r1());
        }
        return s + " ";
    }

    public String toString() {
        if (r1() == 0)
            return "NOP";
        return mnemonic() + "   $r" + r2();
    }
}
