package com.ibm.jvm.zseries;


import com.ibm.jvm.util.*;
import java.util.*;
import java.io.*;


/**
 *  @author David Griffiths <tt>&lt;dave@prim.demon.co.uk&gt;</tt>
 */

public abstract class Instruction {

    Engine engine;

    public abstract int length();

    public abstract String toString();

    public abstract String mnemonic();

    public int nextAddress(int address) {
        return address + length();
    }

    static String hex(int word) {
        String s = Integer.toHexString(word);

        for (int i = s.length(); i < 8; i++)
            s = "0" + s;
        return s;
    }

    static String hx(int word) {
        return Integer.toHexString(word);
    }
}
