package com.ibm.jvm.zseries;


/**
 *  @author David Griffiths <tt>&lt;dave@prim.demon.co.uk&gt;</tt>
 */

public abstract class RRInstruction extends Instruction {

    short word;

    RRInstruction(Engine engine, int word) {
        this.engine = engine;
        this.word = (short) (word >> 16);
    }

    public int length() {
        return 2;
    }

    int r1() {
        return (word >> 4) & 0xf;
    }

    int r2() {
        return word & 0xf;
    }

    public String toString() {
        return mnemonic() + "   $r" + r1() + ", $r" + r2();
    }
}
