package com.ibm.jvm.zseries;


/**
 *  @author David Griffiths <tt>&lt;dave@prim.demon.co.uk&gt;</tt>
 */

public abstract class RSInstruction extends Instruction {

    int word;
    boolean mask;

    RSInstruction() {}

    public int length() {
        return 4;
    }

    int r1() {
        return (word >> 20) & 0xf;
    }

    int r3() {
        return (word >> 16) & 0xf;
    }

    int b2() {
        return (word >> 12) & 0xf;
    }

    int d2() {
        return word & 0xfff;
    }

    public String toString() {
        String m3 = mask ? "" : "$r";

        return mnemonic() + "   $r" + r1() + "," + m3 + r3() + ",x'" + hx(d2()) + "'($r" + b2() + ")";
    }
}
