package com.ibm.jvm.zseries;


/**
 *  @author David Griffiths <tt>&lt;dave@prim.demon.co.uk&gt;</tt>
 */

public abstract class SIInstruction extends Instruction {

    int word;

    SIInstruction() {}

    public int length() {
        return 4;
    }

    int b1() {
        return (word >> 12) & 0xf;
    }

    int d1() {
        return word & 0xfff;
    }

    int i2() {
        return (word >> 16) & 0xff;
    }

    public String toString() {
        return mnemonic() + "   x'" + hx(d1()) + "'($r" + b1() + "), x'" + hx(i2()) + "'";
    }
}
