package com.ibm.jvm.zseries;


/**
 *  @author David Griffiths <tt>&lt;dave@prim.demon.co.uk&gt;</tt>
 */

public abstract class SSInstruction extends Instruction {

    int word1;
    int word2;

    SSInstruction(Engine engine, int word1, int word2) {
        this.engine = engine;
        this.word1 = word1;
        this.word2 = word2;
    }

    public int length() {
        return 6;
    }

    int l() {
        return (word1 >> 16) & 0xff;
    }

    int b1() {
        return (word1 >> 12) & 0xf;
    }

    int d1() {
        return word1 & 0xfff;
    }

    int b2() {
        return (word2 >> 28) & 0xf;
    }

    int d2() {
        return (word2 >> 16) & 0xfff;
    }

    public String toString() {
        return mnemonic() + "   x'" + hx(d1()) + "'(" + hx(l()) + ",$r" + b1() + "),x'" + hx(d2()) + "'($r" + b2() + ")";
    }
}
