package com.wcs.parse;

public class CharFilter implements CharHandler {

    CharHandler next;
    CharHandler prev;

    CharFilter(CharHandler next, CharHandler prev) {
        this.next = next;
        this.prev = prev;
    }

    public void handleAlpha(char c) {
        next.handleAlpha(c);
    }

    public void handleNumeric(char c) {
        next.handleNumeric(c);
    }

    public void handleSpace(char c) {
        next.handleSpace(c);
    }

    public void handlePunctuation(char c) {
        next.handlePunctuation(c);
    }

    public void handleEOF() {
        next.handleEOF();
    }

    public CharHandler next() {
        return next;
    }

    public void setNext(CharHandler next) {
        this.next = next;
    }

    public void push(CharHandler handler) {
        prev.setNext(handler);
	handler.setNext(this);
    }

    public void pop() {
        prev.setNext(next);
    }
}
