package com.wcs.parse;

public class CommentFilter extends CharFilter {

    boolean foundSlash;
    boolean foundStar;
    boolean foundComment;
    int indent;
    StringBuffer buf;

    public CommentFilter(CharHandler next, CharHandler prev) {
        super(next, prev);
    }

    public void handlePunctuation(char c) {
        if (c == '/') {
	    if (foundStar) {
	        buf.append("*/");
		for (CharHandler next = this.next; next != null; next = next.next()) {
		    if (next instanceof CommentHandler) {
		        ((CommentHandler)next).handleComment(buf.toString());
			break;
		    }
		}
		//forward(new CommentEvent(buf.toString()), CommentHandler.class);
		foundStar = false;
		foundComment = false;
	    } else {
	        foundSlash = true;
	    }
	    return;
	} else if (c == '*') {
	    if (foundSlash) {
	        buf = new StringBuffer("/*");
		foundSlash = false;
		foundComment = true;
	    } else {
	        foundStar = true;
	    }
	    return;
        } else {
	    foundSlash = false;
	    foundStar = false;
	}
        if (foundComment) {
	    buf.append(c);
        } else {
	    next.handleChar(c);
        }
    }
}
