package com.wcs.parse;
import java.io.*;

public class ParserReader extends PushbackReader {

    int linenumber = 1;
    StringBuffer line = new StringBuffer();
    StringBuffer lastline;

    ParserReader(Reader in) {
        super(in);
    }

    public void pushback(char c) throws Exception {
        super.unread(c);
	if (c == '\n') {
	    line = lastline;
	    linenumber--;
	} else 
	    line.deleteCharAt(line.length() - 1);
    }

    public char readChar() throws IOException {
        char c = (char)read();
	if (c == '\n') {
	    linenumber++;
	    lastline = line;
	    line = new StringBuffer();
	} else {
	    line.append(c);
	}
	return c;
    }

    public void error(String s) throws Exception {
	if (line.length() == 0)
	    throw new Exception(s + ": " + lastline);
        line.insert(line.length() - 1, " >>> ");
	line.append(" <<< ");
	int c;
	while ((c = (char)read()) != '\n')
	    line.append((char)c);
	throw new Exception(s + ": " + line);
    }
}
