package com.wcs.parse;

import java.io.*;

public class ReaderToParser {
    Reader reader;
    CharHandler parser;

    public ReaderToParser(Reader reader, CharHandler parser) {
        this.reader = reader;
	this.parser = parser;
    }

    public void parse() throws Exception {
        int c;
	while ((c = reader.read()) != -1) {
            if (c == ' ' || c == '\n' || c == '\t') {
	        parser.handleSpace((char)c);
	    } else if ((c >= 'a' && c <= 'z') || (c >= 'A' && c <= 'Z')) {
	        parser.handleAlpha((char)c);
	    } else if (c >= '0' && c <= '9') {
	        parser.handleNumeric((char)c);
	    } else {
	        parser.handlePunctuation((char)c);
	    }
	}
	parser.handleEOF();
    }
}

